// SmartADCEVCDlg.cpp :  
//

#include "stdafx.h"
#include "SmartADCEVC.h"
#include "SmartADCEVCDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CSmartADCEVCDlg ȭ 

CSmartADCEVCDlg::CSmartADCEVCDlg(CWnd* pParent /*=NULL*/)
: CDialog(CSmartADCEVCDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSmartADCEVCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CHECK1, m_Filtering);
	DDX_Control(pDX, IDC_RADIO4, m_AIN3);
	DDX_Control(pDX, IDC_RADIO3, m_AIN2);
	DDX_Control(pDX, IDC_RADIO2, m_AIN1);
	DDX_Control(pDX, IDC_RADIO1, m_AIN0);
	DDX_Control(pDX, IDC_LABADC, m_LabADC);
	DDX_Control(pDX, IDC_LABMAX, m_labMax);
	DDX_Control(pDX, IDC_LABMIN, m_labMin);
	DDX_Control(pDX, IDC_LABDIFF, m_labDiff);
}

BEGIN_MESSAGE_MAP(CSmartADCEVCDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, OnADCStart)
	ON_BN_CLICKED(IDC_BUTTON2, OnStop)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_BUTTON3, &CSmartADCEVCDlg::OnBnClickedButton3)
END_MESSAGE_MAP()


// CSmartADCEVCDlg ޽ ó

BOOL CSmartADCEVCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//  ȭ   մϴ.  α׷  â ȭ ڰ ƴ 쿡
	//  ӿũ  ۾ ڵ մϴ.
	SetIcon(m_hIcon, TRUE);			// ū  մϴ.
	SetIcon(m_hIcon, FALSE);		//   մϴ.

	// TODO: ⿡ ߰ ʱȭ ۾ ߰մϴ.
	m_AIN0.SetCheck(BST_CHECKED);


	// ̽ ȹ  (̽ νϽ  óѴ.)
	m_SmartADC.SetADCPrescale(49);


	return TRUE;  // Ŀ Ʈѿ   TRUE ȯմϴ.
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CSmartADCEVCDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_SMARTADCEVC_DIALOG_WIDE) : 
		MAKEINTRESOURCE(IDD_SMARTADCEVC_DIALOG));
	}
}
#endif


void CSmartADCEVCDlg::OnADCStart() 
{
	// A/D Converter   100ms ֱ ǥ ϱ  Ÿ̸  Ȱȭ 
	SetTimer(3, 100, NULL);
}

void CSmartADCEVCDlg::OnStop() 
{
	// A/D Converter    Ÿ̸  Ŵ
	KillTimer(3);
}

void CSmartADCEVCDlg::OnTimer(UINT nIDEvent) 
{
	// 100ms   õ Է ä ´.
	int iSelCh = GetSelectCh();

	CString strADC;

	m_iNowADC = m_SmartADC.GetADCData(iSelCh);

	// m_iNowADC m_iMax  ū ִ밪 
	if(m_iMax < m_iNowADC)
	{
		m_iMax = m_iNowADC;
	}

	// m_iNowADC m_iMin   ּҰ 
	if(m_iMin > m_iNowADC)
	{
		m_iMin = m_iNowADC;
	}

	m_iDiff = m_iMax-m_iMin;

	CString strTemp;

	strTemp.Format(L"%d", m_iMax);
	m_labMax.SetWindowTextW(strTemp);

	strTemp.Format(L"%d", m_iMin);
	m_labMin.SetWindowTextW(strTemp);

	// ִ밪  ּҰ ̰ ǥ
	strTemp.Format(L"%d", m_iDiff);
	m_labDiff.SetWindowTextW(strTemp);

	// õ ä Ƴα׵͸ ȯ Ͽ  ڿ ´.
	strADC.Format(L"A/D Converter : %d", m_SmartADC.GetADCData(iSelCh));

	// ȭ鿡 ȯ ǥ
	m_LabADC.SetWindowText(strADC);

	CDialog::OnTimer(nIDEvent);
}

//  õ ADC ä ´.
int CSmartADCEVCDlg::GetSelectCh()
{
	if(m_AIN0.GetCheck() == BST_CHECKED)
	{
		return 0;
	}
	else if(m_AIN1.GetCheck() == BST_CHECKED)
	{
		return 1;
	}
	else if(m_AIN2.GetCheck() == BST_CHECKED)
	{
		return 2;
	}
	else
	{
		return 3;
	}

	return 0;
}

// Filtering   θ  մϴ.
void CSmartADCEVCDlg::OnCheck1() 
{
	if(m_Filtering.GetCheck() == BST_CHECKED)
	{
		m_SmartADC.SetFiltering(TRUE);

	}
	else
	{
		m_SmartADC.SetFiltering(FALSE);
	}
}

void CSmartADCEVCDlg::OnBnClickedButton3()
{
	m_iMax = m_iNowADC;
	m_iMin = m_iNowADC;
}
