///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Class SmartADC  C++(EVC++, Visual Studio 2005, 2008) ϵ Wrapping ClassԴϴ.
//  Class ϱ ؼ SmartADCWrap.h SmartADCWrap.cpp  Ʈ Ͽ Ͻñ ٶϴ.
//    Ե "DLL\IEC667HWCON.dll" Ǵ ϰ   Ͽ Ͻñ ٶϴ.
//  
// ڼ  SmartX ޴  Ͻñ ٶϴ.
//
// SmartX copyright(c)2002 All rights reserved by HNS Corp.   www.hnsts.co.kr
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "SmartADCWrap.h"

CSmartADCWrap::CSmartADCWrap(void)
{
	m_hInst = LoadLibrary(L"IEC667HWCON.dll");

	if(m_hInst == NULL)
	{
		AfxMessageBox(L"IEC667HWCON.dll File Not Found...!!!");
		m_hInst = NULL;
		return;
	}

		// ̽ ȹ  (̽ νϽ óѴ.)
	m_pfSetADCPrescale = (SetADCPrescaleEx)GetProcAddress(m_hInst, _T("SetADCPrescale"));
	m_pfSetFiltering = (SetFilteringEx)GetProcAddress(m_hInst, _T("SetFiltering"));
	m_pfGetADCData = (GetADCDataEx)GetProcAddress(m_hInst, _T("GetADCData"));
	m_pfGetDetailFilteringADCData = (GetDetailFilteringADCDataEx)GetProcAddress(m_hInst, _T("GetDetailFilteringADCData"));
}

CSmartADCWrap::~CSmartADCWrap(void)
{
	if(m_hInst != NULL)
	{
		FreeLibrary(m_hInst);
	}
}

// ADCPrescale  
void CSmartADCWrap::SetADCPrescale(unsigned long lPrescale)
{
	m_pfSetADCPrescale(lPrescale);
}

// Filtering Enable üũ 
void CSmartADCWrap::SetFiltering (bool bEnable)
{
	m_pfSetFiltering(bEnable);
}

// AD ȯ   ȯ
unsigned int CSmartADCWrap::GetADCData(int iCh)
{
	return m_pfGetADCData(iCh);
}

// AD ȯ   ڸ  ͸Ͽ ȯ.
// iCh : Ƴα Է ä
// iRawdataCnt : ͸  ܺ Ƴα ȣ 
// iAvailableCnt : RawdataCnt Max, Min    ȣ 
unsigned int CSmartADCWrap::GetDetailFilteringADCData(int iCh , int iRawdataCnt, int iAvailableCnt)
{
	return m_pfGetDetailFilteringADCData(iCh, iRawdataCnt, iAvailableCnt);
}