// SmartBatteryEVCDlg.cpp :  
//

#include "stdafx.h"
#include "SmartBatteryEVC.h"
#include "SmartBatteryEVCDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// ڿ Ҽ   ȯ chart -> double
// Windows Xp, 98, Vista, 7  ִ API Windows CE   
double wtof( const TCHAR *string )
{
	double dRet = 0;
	int  d, r, n;

	n = wcslen(string);
	r = -1;

	for (int i = 0; i < n; i++) 
	{
		if (string[i] == _T('.') ) 
		{ 
			r = i;
			continue;
		}

		if (!iswdigit(string[i]))
		{
			return 0;
		}

		d = string[i] - _T('0');
		dRet += d;
		dRet *= 10;
	}

	if( r == -1 )
	{
		r = n - 1;
	}

	dRet /= pow(10, n-r);

	return dRet;
}

// CSmartBatteryEVCDlg ȭ 

CSmartBatteryEVCDlg::CSmartBatteryEVCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSmartBatteryEVCDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSmartBatteryEVCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LABPOWERSTATUS, m_LabPowerStatus);
	DDX_Control(pDX, IDC_LABBATTERYVOL, m_LabBatteryVolt);
	DDX_Control(pDX, IDC_LABBBTTERYPER, m_LabBatteryPercent);
	DDX_Control(pDX, IDC_TXTMAXVOLT, m_TxtMaxVolt);
	DDX_Control(pDX, IDC_TXTMINVOLT, m_TxtMinVolt);
	DDX_Control(pDX, IDC_TXTOFFSETVOLT, m_TxtOffsetVolt);
}

BEGIN_MESSAGE_MAP(CSmartBatteryEVCDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_EN_SETFOCUS(IDC_TXTMAXVOLT, &CSmartBatteryEVCDlg::OnEnSetfocusTxtmaxvolt)
	ON_EN_KILLFOCUS(IDC_TXTMAXVOLT, &CSmartBatteryEVCDlg::OnEnKillfocusTxtmaxvolt)
	ON_EN_SETFOCUS(IDC_TXTMINVOLT, &CSmartBatteryEVCDlg::OnEnSetfocusTxtminvolt)
	ON_EN_KILLFOCUS(IDC_TXTMINVOLT, &CSmartBatteryEVCDlg::OnEnKillfocusTxtminvolt)
	ON_EN_SETFOCUS(IDC_TXTOFFSETVOLT, &CSmartBatteryEVCDlg::OnEnSetfocusTxtoffsetvolt)
	ON_EN_KILLFOCUS(IDC_TXTOFFSETVOLT, &CSmartBatteryEVCDlg::OnEnKillfocusTxtoffsetvolt)
	ON_BN_CLICKED(IDC_BUTPOWEROFF, &CSmartBatteryEVCDlg::OnBnClickedButpoweroff)
	ON_BN_CLICKED(IDC_BUTAPPLY, &CSmartBatteryEVCDlg::OnBnClickedButapply)
END_MESSAGE_MAP()


// CSmartBatteryEVCDlg ޽ ó

BOOL CSmartBatteryEVCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//  ȭ   մϴ.  α׷  â ȭ ڰ ƴ 쿡
	//  ӿũ  ۾ ڵ մϴ.
	SetIcon(m_hIcon, TRUE);			// ū  մϴ.
	SetIcon(m_hIcon, FALSE);		//   մϴ.

	// TODO: ⿡ ߰ ʱȭ ۾ ߰մϴ.

	// , ּ, Offset  
	m_TxtMaxVolt.SetWindowTextW(L"8.3");
	m_TxtMinVolt.SetWindowTextW(L"6.5");
	m_TxtOffsetVolt.SetWindowTextW(L"0.45");

	// TextBox   о SmartBattery 
	SettingsApply();

	//  Battery  ϱ  Ÿ̸  
    // 1ʸ Battery  ŵ
	SetTimer(3, 1000, NULL);
	
	return TRUE;  // Ŀ Ʈѿ   TRUE ȯմϴ.
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CSmartBatteryEVCDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_SMARTBATTERYEVC_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_SMARTBATTERYEVC_DIALOG));
	}
}
#endif


void CSmartBatteryEVCDlg::OnClose()
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.

	// α׷  Ÿ̸ 
	KillTimer(3);

	CDialog::OnClose();
}

void CSmartBatteryEVCDlg::OnTimer(UINT_PTR nIDEvent)
{	
	// 1ʸ Battery   ̺Ʈ 
	if(nIDEvent == 3)
	{		
		CString strTemp;

		//  ܺ DC  ޵Ǵ Ȯ
		if(m_SmartBattery.IsExtDCPowerIN() == true)
		{
			//  Bateryθ 
			m_LabPowerStatus.SetWindowTextW(L"Battery");		
		}
		else
		{
			//  Battery ̸ ܺ DC  ޵Ǵ 
			m_LabPowerStatus.SetWindowTextW(L"External DC Power");		
		}

		//  Battery а 
		strTemp.Format(L"%.3f[V]", m_SmartBattery.GetBatteryVoltage());		
		m_LabBatteryVolt.SetWindowTextW(strTemp);

		//  Battery    ϰ ǥ
		strTemp.Format(L"%d%[%%]", m_SmartBattery.GetBatteryPercent());		
		m_LabBatteryPercent.SetWindowTextW(strTemp);

	}

	CDialog::OnTimer(nIDEvent);
}

//  м TextBox õɰ ڸ Էϵ Ű 
void CSmartBatteryEVCDlg::OnEnSetfocusTxtmaxvolt()
{
	SipShowIM(SIPF_ON);
}

//  м TextBox    Ű 
void CSmartBatteryEVCDlg::OnEnKillfocusTxtmaxvolt()
{
	SipShowIM(SIPF_OFF);
}

// ּ м TextBox õɰ ڸ Էϵ Ű 
void CSmartBatteryEVCDlg::OnEnSetfocusTxtminvolt()
{
	SipShowIM(SIPF_ON);
}

// ּ м TextBox    Ű 
void CSmartBatteryEVCDlg::OnEnKillfocusTxtminvolt()
{
	SipShowIM(SIPF_OFF);
}

// Offset м TextBox õɰ ڸ Էϵ Ű 
void CSmartBatteryEVCDlg::OnEnSetfocusTxtoffsetvolt()
{
	SipShowIM(SIPF_ON);
}

// Offset м TextBox    Ű 
void CSmartBatteryEVCDlg::OnEnKillfocusTxtoffsetvolt()
{
	SipShowIM(SIPF_OFF);
}

// TextBox   о SmartBattery Ӽ 
void CSmartBatteryEVCDlg::SettingsApply(void)
{
	double fMaxVolt, fMinVolt, fOffsetVolt;
	CString strTemp;

	//  м
	m_TxtMaxVolt.GetWindowTextW(strTemp);
	fMaxVolt = wtof(strTemp);

	// ּ м
	m_TxtMinVolt.GetWindowTextW(strTemp);
	fMinVolt = wtof(strTemp);

	// Offset м
	m_TxtOffsetVolt.GetWindowTextW(strTemp);
	fOffsetVolt = wtof(strTemp);

	m_SmartBattery.SetBatteryVoltageLimit(fMaxVolt, fMinVolt);
	m_SmartBattery.SetExtDCPowerInOffsetVoltage(fOffsetVolt);
}

// IEC266/667  OFF մϴ. 2  OFF
void CSmartBatteryEVCDlg::OnBnClickedButpoweroff()
{
	m_SmartBattery.PowerOFF();
}

// Battery Ķ  
void CSmartBatteryEVCDlg::OnBnClickedButapply()
{
	SettingsApply();
}
