#pragma once

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Class SmartBattery  C++(EVC++) Visual Studio 2005, 2008 ϵ Wrapping ClassԴϴ.
//  Class ϱ ؼ SmartBatteryWrap.h SmartBatteryWrap.cpp  Ʈ Ͽ Ͻñ ٶϴ.
//  
// ڼ  SmartX-Programming Guide  Ͻñ ٶϴ.
//
// www.hnsts.co.kr
// SmartX copyright(c)2008 All rights reserved by HNS Corp.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef void (*SetBatteryVoltageLimitEx)(double fMaxVoltage, double fMinVoltage);
typedef void (*SetExtDCPowerInOffsetVoltageEx)(double fOffsetVoltage);
typedef bool (*IsExtDCPowerINEx)();
typedef void (*PowerOFFEx)();
typedef double (*GetBatteryVoltageEx)();
typedef int (*GetBatteryPercentEx)();


class CSmartBatteryWrap
{
private:
	HINSTANCE						m_hInst;

	SetBatteryVoltageLimitEx		m_pfSetBatteryVoltageLimit;
	SetExtDCPowerInOffsetVoltageEx  m_pfSetExtDCPowerInOffsetVoltage;
	IsExtDCPowerINEx				m_pfIsExtDCPowerIN;
	PowerOFFEx						m_pfPowerOFF;
	GetBatteryVoltageEx				m_pfGetBatteryVoltage;
	GetBatteryPercentEx				m_pfGetBatteryPercent;

public:
	CSmartBatteryWrap(void);
	virtual ~CSmartBatteryWrap(void);

public:
	void SetBatteryVoltageLimit(double fMaxVoltage, double fMinVoltage);
	void SetExtDCPowerInOffsetVoltage(double fOffsetVoltage);
	bool IsExtDCPowerIN();
	void PowerOFF();
	double GetBatteryVoltage();
	int GetBatteryPercent();	
};
