#include <windows.h> // ð   header

class CTimePerformance
{
	private:
		LONGLONG m_llQPFTicksPerSec;
		LONGLONG m_llLastElapsedTime;
		float m_fElapsedTime;
		bool m_bUsingQPF;
	public:

	CTimePerformance ()
	{
		// е ð ϱ  Լ
		// windows.h ̹ ǵǾ 
		/*QueryPerformanceCounter( &TickPerSec );
		BeginTime.QuadPart = 0;
		EndTime.QuadPart = 0;
		CurrTime.QuadPart = 0;*/


		m_bUsingQPF = false;
	}


	void Begin( void ) 
	{ 
		LARGE_INTEGER qwTicksPerSec, qwTime; 
		m_bUsingQPF = (bool)(QueryPerformanceFrequency( &qwTicksPerSec ) != 0); 
		
   
		if(!m_bUsingQPF) 
		{
			return; 
		}
	    
		m_llQPFTicksPerSec = qwTicksPerSec.QuadPart; 
   
		QueryPerformanceCounter( &qwTime ); 

		m_llLastElapsedTime = qwTime.QuadPart; 

	}

	float GetElapsedTime( void ) 
	{ 		
		return m_fElapsedTime; 
	}	 
	
	void End ()
	{
		if(!m_bUsingQPF) 
		{
			return; 
		}
   
	    LARGE_INTEGER qwTime; 

		QueryPerformanceCounter( &qwTime ); 
   

		m_fElapsedTime = (float)((double) ( qwTime.QuadPart - m_llLastElapsedTime ) / (double) m_llQPFTicksPerSec); 

		//m_llLastElapsedTime = qwTime.QuadPart; 
	}

};