// SmartFTPEVCDlg.cpp :  
// #pragma warning(disable : 4996)

#include "stdafx.h"
#include "SmartFTPEVC.h"
#include "SmartFTPEVCDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CSmartFTPEVCDlg ȭ 

CSmartFTPEVCDlg::CSmartFTPEVCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSmartFTPEVCDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSmartFTPEVCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TXTFTPPATH1, m_txtFtpPath1);
	DDX_Control(pDX, IDC_TXTFTPPATH2, m_txtFtpPath2);
	DDX_Control(pDX, IDC_TXTLOCALPATH1, m_TxtLocalPath1);
	DDX_Control(pDX, IDC_TXTLOCALPATH2, m_TxtLocalPath2);
	DDX_Control(pDX, IDC_LABDOWNPER, m_LabDownPer);
	DDX_Control(pDX, IDC_LABUPPER, m_LabUploadPer);
	DDX_Control(pDX, IDC_TXTCREATEFOLDER, m_txtCreateFolder);
	DDX_Control(pDX, IDC_DELFOLDER, m_txtDelFolder);
	DDX_Control(pDX, IDC_TXTSETPATH, m_txtSetPath);
	DDX_Control(pDX, IDC_FILELIST, m_FileLists);
}

BEGIN_MESSAGE_MAP(CSmartFTPEVCDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTCONNECT, &CSmartFTPEVCDlg::OnBnClickedButconnect)
	ON_BN_CLICKED(IDC_BUTDISCONN, &CSmartFTPEVCDlg::OnBnClickedButdisconn)
	ON_BN_CLICKED(IDC_BUTDOWNLOAD, &CSmartFTPEVCDlg::OnBnClickedButdownload)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTUPLOAD, &CSmartFTPEVCDlg::OnBnClickedButupload)
	ON_BN_CLICKED(IDC_BUTCREATEFOLDER, &CSmartFTPEVCDlg::OnBnClickedButcreatefolder)
	ON_BN_CLICKED(IDC_BUTDELFOLDER, &CSmartFTPEVCDlg::OnBnClickedButdelfolder)
	ON_BN_CLICKED(IDC_BUTSETPATH, &CSmartFTPEVCDlg::OnBnClickedButsetpath)
	ON_BN_CLICKED(IDC_BUTFILELIST, &CSmartFTPEVCDlg::OnBnClickedButfilelist)
END_MESSAGE_MAP()


// CSmartFTPEVCDlg ޽ ó

BOOL CSmartFTPEVCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//  ȭ   մϴ.  α׷  â ȭ ڰ ƴ 쿡
	//  ӿũ  ۾ ڵ մϴ.
	SetIcon(m_hIcon, TRUE);			// ū  մϴ.
	SetIcon(m_hIcon, FALSE);		//   մϴ.

	return TRUE;  // Ŀ Ʈѿ   TRUE ȯմϴ.
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CSmartFTPEVCDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_SMARTFTPEVC_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_SMARTFTPEVC_DIALOG));
	}
}
#endif

// FTP  ư
void CSmartFTPEVCDlg::OnBnClickedButconnect()
{
	// FTP ϱ    մϴ.
	m_SmartFTP.SetConnectInfo(L"192.168.1.22", 21, L"hns", L"hns", FALSE); 

	// FTP  
	if(m_SmartFTP.Connect() == TRUE)
	{
		AfxMessageBox(L"");
	}
	else
	{
		AfxMessageBox(L" ");
	}

}

// FTP  ư
void CSmartFTPEVCDlg::OnBnClickedButdisconn()
{
	m_SmartFTP.DisConnect();
}

//  ٿε ư
void CSmartFTPEVCDlg::OnBnClickedButdownload()
{
	TCHAR strFTPPath[1000];
	TCHAR strLocalPath[1000];

	//  Էµ FTP Localθ о ɴϴ.
	m_txtFtpPath1.GetWindowTextW(strFTPPath, 1000);
	m_TxtLocalPath1.GetWindowTextW(strLocalPath, 1000);

	// Էµ   ٿε մϴ.
	if(m_SmartFTP.FileDownload(strFTPPath, strLocalPath) == TRUE)
	{
		// ٿε  ¸ ǥϱ  Ÿ̸Ӹ  մϴ.
		SetTimer(3, 500, NULL);
	}
}

//  ε ư
void CSmartFTPEVCDlg::OnBnClickedButupload()
{
	TCHAR strFTPPath[1000];
	TCHAR strLocalPath[1000];

	//  Էµ FTP Localθ о ɴϴ.
	m_txtFtpPath2.GetWindowTextW(strFTPPath, 1000);
	m_TxtLocalPath2.GetWindowTextW(strLocalPath, 1000);

	// Էµ   ε մϴ.
	if(m_SmartFTP.FileUpload(strLocalPath, strFTPPath) == TRUE)
	{
		// ε  ¸ ǥϱ  Ÿ̸Ӹ  մϴ.
		SetTimer(7, 500, NULL);
	}
}

//   ư
void CSmartFTPEVCDlg::OnBnClickedButcreatefolder()
{
	TCHAR strFTPFolderName[100];

	//  Էµ  ̸ о ɴϴ.
	m_txtCreateFolder.GetWindowTextW(strFTPFolderName, 100);

	//   ο   մϴ. 
	m_SmartFTP.CreateFolder(strFTPFolderName);
}

//   ư
void CSmartFTPEVCDlg::OnBnClickedButdelfolder()
{
	TCHAR strFTPFolderName[100];

	//  Էµ  ̸ о ɴϴ.
	m_txtDelFolder.GetWindowTextW(strFTPFolderName, 100);

	//   ο   մϴ. 
	m_SmartFTP.DeleteFolder(strFTPFolderName);
}

//    ư
void CSmartFTPEVCDlg::OnBnClickedButsetpath()
{
	TCHAR strFTPPath[500];

	//  Էµ θ о ɴϴ.
	m_txtSetPath.GetWindowTextW(strFTPPath, 500);

	//  θ  մϴ.
	m_SmartFTP.SetCurrentDirectory(strFTPPath);
}

// ϰ  Ʈ ǥ ư 
void CSmartFTPEVCDlg::OnBnClickedButfilelist()
{
	TCHAR			strListFileList[3000];
	CString			strBlock;
	TCHAR*			fileItems;
	TCHAR			sepA[] = L":";
	bool			bFolder;

	TCHAR strFTPPath[500];

	m_SmartFTP.GetCurrentDirectory(strFTPPath);
		

	//    ϰ  Ʈ  
	if(m_SmartFTP.GetFileList(strListFileList) == TRUE)
	{	
		// Ʈ   
		m_FileLists.ResetContent();

		// о Ϲ  Ʈ (:)   ׸ ϴ.
		fileItems = wcstok( strListFileList, sepA);	

		while(fileItems != NULL)
		{
			strBlock.Format(L"%s", fileItems);

			// Ʈ ϶Ǵ ׸ ߰ մϴ.
			m_FileLists.AddString(strBlock);
			
			// Get next token
			fileItems = wcstok(NULL, sepA);
		}
	}
	else
	{
		// Ʈ   
		m_FileLists.ResetContent();
	}
}

//  ٿε  ε Ǵ ¸ ǥϱ Ÿ̸ ̺Ʈ
void CSmartFTPEVCDlg::OnTimer(UINT_PTR nIDEvent)
{
	CString strMsg;

	// ٿε  
	if(nIDEvent == 3)
	{
		//  ٿε   б
		int i = m_SmartFTP.GetPercentage();

		// ٿε 
		if(i == -1)
		{
			KillTimer(3);
			AfxMessageBox(L"ٿε ");
		}
		else 
		{
			//  ٿε   ǥ
			strMsg.Format(L"%d\%%", i);
			m_LabDownPer.SetWindowTextW(strMsg);
			
			if(i == 100)
			{
				// ٿε Ϸ
				KillTimer(3);
				m_LabDownPer.SetWindowTextW(L"Ϸ");
			}
		}
	}
	
	// ε  
	if(nIDEvent == 7)
	{
		//  ε   б
		int i = m_SmartFTP.GetPercentage();

		// ε 
		if(i == -1)
		{
			KillTimer(7);
			AfxMessageBox(L"ε ");
		}
		else 
		{
			//  ε   ǥ
			strMsg.Format(L"%d\%%", i);
			m_LabUploadPer.SetWindowTextW(strMsg);
			if(i == 100)
			{
				// ε Ϸ
				KillTimer(7);
				m_LabUploadPer.SetWindowTextW(L"Ϸ");
			}
		}
	}
	CDialog::OnTimer(nIDEvent);
}
