///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Class SmartGPIO  C++(EVC++, Visual Studio 2005, 2008) ϵ Wrapping ClassԴϴ.
//  Class ϱ ؼ SmartGPIOWrap.h SmartGPIOWrap.cpp  Ʈ Ͽ Ͻñ ٶϴ.
//    Ե "DLL\IEC667HWCON.dll" Ǵ ϰ   Ͽ Ͻñ ٶϴ.
//  
// ڼ  SmartX ޴  Ͻñ ٶϴ.
//
// SmartX copyright(c)2002 All rights reserved by HNS Corp.   www.hnsts.co.kr
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SmartGPIOWrap.h"

CSmartGPIOWrap::CSmartGPIOWrap(void)
{
	m_hInst = LoadLibrary(L"IEC667HWCON.dll");

	if(m_hInst == NULL)
	{
		AfxMessageBox(L"IEC667HWCON.DLL File Not Found...!!!");
		return;
	}
	

	// Port-A Interface Function Pointer ȹ
    m_pfSetPortACfgs = (SetPortCfg)GetProcAddress(m_hInst, _T("SetPortACfg"));
	m_pfSetPortABitCfg = (SetPortBitCfg)GetProcAddress(m_hInst, _T("SetPortABitCfg"));
	m_pfSetPortADatas = (SetPortData)GetProcAddress(m_hInst, _T("SetPortAData"));
	m_pfSetPortABitData = (SetPortBit)GetProcAddress(m_hInst, _T("SetPortABit"));
	m_pfGetPortADatas = (GetPortData)GetProcAddress(m_hInst, _T("GetPortAData"));
	m_pfGetPortABitData = (GetPortBit)GetProcAddress(m_hInst, _T("GetPortABit"));


	// Port-B Interface Function Pointer ȹ
	m_pfSetPortBCfgs = (SetPortCfg)GetProcAddress(m_hInst, _T("SetPortBCfg"));
	m_pfSetPortBBitCfg = (SetPortBitCfg)GetProcAddress(m_hInst, _T("SetPortBBitCfg"));
	m_pfSetPortBDatas = (SetPortData)GetProcAddress(m_hInst, _T("SetPortBData"));
	m_pfSetPortBBitData = (SetPortBit)GetProcAddress(m_hInst, _T("SetPortBBit"));
	m_pfGetPortBDatas = (GetPortData)GetProcAddress(m_hInst, _T("GetPortBData"));
	m_pfGetPortBBitData = (GetPortBit)GetProcAddress(m_hInst, _T("GetPortBBit"));
	

	// Port-C Interface Function Pointer ȹ
	m_pfSetPortCCfgs = (SetPortCfg)GetProcAddress(m_hInst, _T("SetPortCCfg"));
	m_pfSetPortCBitCfg = (SetPortBitCfg)GetProcAddress(m_hInst, _T("SetPortCBitCfg"));
	m_pfSetPortCDatas = (SetPortData)GetProcAddress(m_hInst, _T("SetPortCData"));
	m_pfSetPortCBitData = (SetPortBit)GetProcAddress(m_hInst, _T("SetPortCBit"));
	m_pfGetPortCDatas = (GetPortData)GetProcAddress(m_hInst, _T("GetPortCData"));
	m_pfGetPortCBitData = (GetPortBit)GetProcAddress(m_hInst, _T("GetPortCBit"));
	
	
	// Port-D Interface Function Pointer ȹ
	m_pfSetPortDCfgs = (SetPortCfg)GetProcAddress(m_hInst, _T("SetPortDCfg"));
	m_pfSetPortDBitCfg = (SetPortBitCfg)GetProcAddress(m_hInst, _T("SetPortDBitCfg"));
	m_pfSetPortDDatas = (SetPortData)GetProcAddress(m_hInst, _T("SetPortDData"));
	m_pfSetPortDBitData = (SetPortBit)GetProcAddress(m_hInst, _T("SetPortDBit"));
	m_pfGetPortDDatas = (GetPortData)GetProcAddress(m_hInst, _T("GetPortDData"));
	m_pfGetPortDBitData = (GetPortBit)GetProcAddress(m_hInst, _T("GetPortDBit"));
	

	// Port-E Interface Function Pointer ȹ
	m_pfSetPortECfgs = (SetPortCfg)GetProcAddress(m_hInst, _T("SetPortECfg"));
	m_pfSetPortEBitCfg = (SetPortBitCfg)GetProcAddress(m_hInst, _T("SetPortEBitCfg"));
	m_pfSetPortEDatas = (SetPortData)GetProcAddress(m_hInst, _T("SetPortEData"));
	m_pfSetPortEBitData = (SetPortBit)GetProcAddress(m_hInst, _T("SetPortEBit"));
	m_pfGetPortEDatas = (GetPortData)GetProcAddress(m_hInst, _T("GetPortEData"));
	m_pfGetPortEBitData = (GetPortBit)GetProcAddress(m_hInst, _T("GetPortEBit"));
	

	// Port-F Interface Function Pointer ȹ
	m_pfSetPortFCfgs = (SetPortCfg)GetProcAddress(m_hInst, _T("SetPortFCfg"));
	m_pfSetPortFBitCfg = (SetPortBitCfg)GetProcAddress(m_hInst, _T("SetPortFBitCfg"));
	m_pfSetPortFDatas = (SetPortData)GetProcAddress(m_hInst, _T("SetPortFData"));
	m_pfSetPortFBitData = (SetPortBit)GetProcAddress(m_hInst, _T("SetPortFBit"));
	m_pfGetPortFDatas = (GetPortData)GetProcAddress(m_hInst, _T("GetPortFData"));
	m_pfGetPortFBitData = (GetPortBit)GetProcAddress(m_hInst, _T("GetPortFBit"));
	

	// Port-G Interface Function Pointer ȹ
	m_pfSetPortGCfgs = (SetPortCfg)GetProcAddress(m_hInst, _T("SetPortGCfg"));
	m_pfSetPortGBitCfg = (SetPortBitCfg)GetProcAddress(m_hInst, _T("SetPortGBitCfg"));
	m_pfSetPortGDatas = (SetPortData)GetProcAddress(m_hInst, _T("SetPortGData"));
	m_pfSetPortGBitData = (SetPortBit)GetProcAddress(m_hInst, _T("SetPortGBit"));
	m_pfGetPortGDatas = (GetPortData)GetProcAddress(m_hInst, _T("GetPortGData"));
	m_pfGetPortGBitData = (GetPortBit)GetProcAddress(m_hInst, _T("GetPortGBit"));
	

	// Port-H Interface Function Pointer ȹ
	m_pfSetPortHCfgs = (SetPortCfg)GetProcAddress(m_hInst, _T("SetPortHCfg"));
	m_pfSetPortHBitCfg = (SetPortBitCfg)GetProcAddress(m_hInst, _T("SetPortHBitCfg"));
	m_pfSetPortHDatas = (SetPortData)GetProcAddress(m_hInst, _T("SetPortHData"));
	m_pfSetPortHBitData = (SetPortBit)GetProcAddress(m_hInst, _T("SetPortHBit"));
	m_pfGetPortHDatas = (GetPortData)GetProcAddress(m_hInst, _T("GetPortHData"));
	m_pfGetPortHBitData = (GetPortBit)GetProcAddress(m_hInst, _T("GetPortHBit"));
}


CSmartGPIOWrap::~CSmartGPIOWrap(void)
{
	FreeLibrary(m_hInst);
}

// PORT-AƮ ϱ Ʈ   ʱȭ
void CSmartGPIOWrap::SetPortABitCfg(int iBitIndex, int iBitCfg)
{
	m_pfSetPortABitCfg(iBitIndex, iBitCfg);
}
// PORT-AƮ ϱ Ʈ ʱȭ. ʱȭ Ʈ Է     
bool CSmartGPIOWrap::SetPortACfgs(int iCon)
{
	return m_pfSetPortACfgs(iCon);
}
// PORT-AƮ     ¸   ϱ  
void CSmartGPIOWrap::SetPortABit(int iBitIndex, int iBool)
{
	m_pfSetPortABitData(iBitIndex, iBool);
}
// PORT-AƮ     ¸ ϱ  
void CSmartGPIOWrap::SetPortADatas(int iPortData)
{
	m_pfSetPortADatas(iPortData);
}
// PORT-AƮ Է   Ʈ Է ¸   Ȯϱ  
unsigned char CSmartGPIOWrap::GetPortABit(int iBitIndex)
{
	return m_pfGetPortABitData(iBitIndex);
}
// PORT-AƮ Է   Ʈ Է ¸ Ȯϱ  
unsigned char CSmartGPIOWrap::GetPortAData()
{
	return m_pfGetPortADatas();
}


// PORT-BƮ ϱ Ʈ   ʱȭ
void CSmartGPIOWrap::SetPortBBitCfg(int iBitIndex, int iBitCfg)
{
	m_pfSetPortBBitCfg(iBitIndex, iBitCfg);
}
// PORT-BƮ ϱ Ʈ ʱȭ. ʱȭ Ʈ Է     
bool CSmartGPIOWrap::SetPortBCfgs(int iCon)
{
	return m_pfSetPortBCfgs(iCon);
}
// PORT-BƮ     ¸   ϱ  
void CSmartGPIOWrap::SetPortBBit(int iBitIndex, int iBool)
{
	m_pfSetPortBBitData(iBitIndex, iBool);
}
// PORT-BƮ     ¸ ϱ  
void CSmartGPIOWrap::SetPortBDatas(int iPortData)
{
	m_pfSetPortBDatas(iPortData);
}
// PORT-BƮ Է   Ʈ Է ¸   Ȯϱ  
unsigned char CSmartGPIOWrap::GetPortBBit(int iBitIndex)
{
	return m_pfGetPortBBitData(iBitIndex);
}
// PORT-BƮ Է   Ʈ Է ¸ Ȯϱ  
unsigned char CSmartGPIOWrap::GetPortBData()
{
	return m_pfGetPortBDatas();
}


// PORT-CƮ ϱ Ʈ   ʱȭ
void CSmartGPIOWrap::SetPortCBitCfg(int iBitIndex, int iBitCfg)
{
	m_pfSetPortCBitCfg(iBitIndex, iBitCfg);
}
// PORT-CƮ ϱ Ʈ ʱȭ. ʱȭ Ʈ Է     
bool CSmartGPIOWrap::SetPortCCfgs(int iCon)
{
	return m_pfSetPortCCfgs(iCon);
}
// PORT-CƮ     ¸   ϱ  
void CSmartGPIOWrap::SetPortCBit(int iBitIndex, int iBool)
{
	m_pfSetPortCBitData(iBitIndex, iBool);
}
// PORT-CƮ     ¸ ϱ  
void CSmartGPIOWrap::SetPortCDatas(int iPortData)
{
	m_pfSetPortCDatas(iPortData);
}
// PORT-CƮ Է   Ʈ Է ¸   Ȯϱ  
unsigned char CSmartGPIOWrap::GetPortCBit(int iBitIndex)
{
	return m_pfGetPortCBitData(iBitIndex);
}
// PORT-CƮ Է   Ʈ Է ¸ Ȯϱ  
unsigned char CSmartGPIOWrap::GetPortCData()
{
	return m_pfGetPortCDatas();
}


// PORT-DƮ ϱ Ʈ   ʱȭ
void CSmartGPIOWrap::SetPortDBitCfg(int iBitIndex, int iBitCfg)
{
	m_pfSetPortDBitCfg(iBitIndex, iBitCfg);
}
// PORT-DƮ ϱ Ʈ ʱȭ. ʱȭ Ʈ Է     
bool CSmartGPIOWrap::SetPortDCfgs(int iCon)
{
	return m_pfSetPortDCfgs(iCon);
}
// PORT-DƮ     ¸   ϱ  
void CSmartGPIOWrap::SetPortDBit(int iBitIndex, int iBool)
{
	m_pfSetPortDBitData(iBitIndex, iBool);
}
// PORT-DƮ     ¸ ϱ  
void CSmartGPIOWrap::SetPortDDatas(int iPortData)
{
	m_pfSetPortDDatas(iPortData);
}
// PORT-DƮ Է   Ʈ Է ¸   Ȯϱ  
unsigned char CSmartGPIOWrap::GetPortDBit(int iBitIndex)
{
	return m_pfGetPortDBitData(iBitIndex);
}
// PORT-DƮ Է   Ʈ Է ¸ Ȯϱ  
unsigned char CSmartGPIOWrap::GetPortDData()
{
	return m_pfGetPortDDatas();
}


// PORT-EƮ ϱ Ʈ   ʱȭ
void CSmartGPIOWrap::SetPortEBitCfg(int iBitIndex, int iBitCfg)
{
	m_pfSetPortEBitCfg(iBitIndex, iBitCfg);
}
// PORT-EƮ ϱ Ʈ ʱȭ. ʱȭ Ʈ Է     
bool CSmartGPIOWrap::SetPortECfgs(int iCon)
{
	return m_pfSetPortECfgs(iCon);
}
// PORT-EƮ     ¸   ϱ  
void CSmartGPIOWrap::SetPortEBit(int iBitIndex, int iBool)
{
	m_pfSetPortEBitData(iBitIndex, iBool);
}
// PORT-EƮ     ¸ ϱ  
void CSmartGPIOWrap::SetPortEDatas(int iPortData)
{
	m_pfSetPortEDatas(iPortData);
}
// PORT-EƮ Է   Ʈ Է ¸   Ȯϱ  
unsigned char CSmartGPIOWrap::GetPortEBit(int iBitIndex)
{
	return m_pfGetPortEBitData(iBitIndex);
}
// PORT-EƮ Է   Ʈ Է ¸ Ȯϱ  
unsigned char CSmartGPIOWrap::GetPortEData()
{
	return m_pfGetPortEDatas();
}


// PORT-FƮ ϱ Ʈ   ʱȭ
void CSmartGPIOWrap::SetPortFBitCfg(int iBitIndex, int iBitCfg)
{
	m_pfSetPortFBitCfg(iBitIndex, iBitCfg);
}
// PORT-FƮ ϱ Ʈ ʱȭ. ʱȭ Ʈ Է     
bool CSmartGPIOWrap::SetPortFCfgs(int iCon)
{
	return m_pfSetPortFCfgs(iCon);
}
// PORT-FƮ     ¸   ϱ  
void CSmartGPIOWrap::SetPortFBit(int iBitIndex, int iBool)
{
	m_pfSetPortFBitData(iBitIndex, iBool);
}
// PORT-FƮ     ¸ ϱ  
void CSmartGPIOWrap::SetPortFDatas(int iPortData)
{
	m_pfSetPortFDatas(iPortData);
}
// PORT-FƮ Է   Ʈ Է ¸   Ȯϱ  
unsigned char CSmartGPIOWrap::GetPortFBit(int iBitIndex)
{
	return m_pfGetPortFBitData(iBitIndex);
}
// PORT-FƮ Է   Ʈ Է ¸ Ȯϱ  
unsigned char CSmartGPIOWrap::GetPortFData()
{
	return m_pfGetPortFDatas();
}


// PORT-GƮ ϱ Ʈ   ʱȭ
void CSmartGPIOWrap::SetPortGBitCfg(int iBitIndex, int iBitCfg)
{
	m_pfSetPortGBitCfg(iBitIndex, iBitCfg);
}
// PORT-GƮ ϱ Ʈ ʱȭ. ʱȭ Ʈ Է    
bool CSmartGPIOWrap::SetPortGCfgs(int iCon)
{
	return m_pfSetPortGCfgs(iCon);
}
// PORT-GƮ     ¸   ϱ  
void CSmartGPIOWrap::SetPortGBit(int iBitIndex, int iBool)
{
	m_pfSetPortGBitData(iBitIndex, iBool);
}
// PORT-GƮ     ¸ ϱ  
void CSmartGPIOWrap::SetPortGDatas(int iPortData)
{
	m_pfSetPortGDatas(iPortData);
}
// PORT-GƮ Է   Ʈ Է ¸   Ȯϱ  
unsigned char CSmartGPIOWrap::GetPortGBit(int iBitIndex)
{
	return m_pfGetPortGBitData(iBitIndex);
}
// PORT-GƮ Է   Ʈ Է ¸ Ȯϱ  
unsigned char CSmartGPIOWrap::GetPortGData()
{
	return m_pfGetPortGDatas();
}


// PORT-HƮ ϱ Ʈ   ʱȭ
void CSmartGPIOWrap::SetPortHBitCfg(int iBitIndex, int iBitCfg)
{
	m_pfSetPortHBitCfg(iBitIndex, iBitCfg);
}
// PORT-HƮ ϱ Ʈ ʱȭ. ʱȭ Ʈ Է    
bool CSmartGPIOWrap::SetPortHCfgs(int iCon)
{
	return m_pfSetPortHCfgs(iCon);
}
// PORT-HƮ     ¸   ϱ  
void CSmartGPIOWrap::SetPortHBit(int iBitIndex, int iBool)
{
	m_pfSetPortHBitData(iBitIndex, iBool);
}
// PORT-HƮ     ¸ ϱ  
void CSmartGPIOWrap::SetPortHDatas(int iPortData)
{
	m_pfSetPortHDatas(iPortData);
}
// PORT-HƮ Է   Ʈ Է ¸   Ȯϱ  
unsigned char CSmartGPIOWrap::GetPortHBit(int iBitIndex)
{
	return m_pfGetPortHBitData(iBitIndex);
}
// PORT-HƮ Է   Ʈ Է ¸ Ȯϱ  
unsigned char CSmartGPIOWrap::GetPortHData()
{
	return m_pfGetPortHDatas();
}

