#pragma once

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Class SmartGPIO  C++(EVC++, Visual Studio 2005, 2008 ϵ Wrapping ClassԴϴ.
//  Class ϱ ؼ SmartGPIOWrap.h SmartGPIOWrap.cpp  Ʈ Ͽ Ͻñ ٶϴ.
//  
// ڼ  SmartX ޴  Ͻñ ٶϴ.
//
// www.hnsts.co.kr
// SmartX copyright(c)2002 All rights reserved by HNS Corp.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Ʈ ϱ Ʈ ʱȭ. ʱȭ Ʈ Է     
typedef bool (*SetPortCfg)(int iCon);

// Ʈ ϱ Ʈ   ʱȭ
typedef void (*SetPortBitCfg)(int iBitIndex, int iBitCfg);

// Ʈ     ¸ ϱ  
typedef void (*SetPortData)(int iPortData);

// Ʈ     ¸   ϱ  
typedef void (*SetPortBit)(int iBitIndex, int iBool);

// Ʈ Է   Ʈ Է ¸ Ȯϱ  
typedef unsigned char (*GetPortData)();

// Ʈ Է   Ʈ Է ¸   Ȯϱ  
typedef unsigned char (*GetPortBit)(int iBitIndex);

class CSmartGPIOWrap
{
private:

	HINSTANCE			m_hInst;

	SetPortCfg			m_pfSetPortACfgs;
	SetPortBitCfg		m_pfSetPortABitCfg;
	SetPortData			m_pfSetPortADatas;
	SetPortBit			m_pfSetPortABitData;
	GetPortData			m_pfGetPortADatas;
	GetPortBit			m_pfGetPortABitData;

	SetPortCfg			m_pfSetPortBCfgs;
	SetPortBitCfg		m_pfSetPortBBitCfg;
	SetPortData			m_pfSetPortBDatas;
	SetPortBit			m_pfSetPortBBitData;
	GetPortData			m_pfGetPortBDatas;
	GetPortBit			m_pfGetPortBBitData;

	SetPortCfg			m_pfSetPortCCfgs;
	SetPortBitCfg		m_pfSetPortCBitCfg;
	SetPortData			m_pfSetPortCDatas;
	SetPortBit			m_pfSetPortCBitData;
	GetPortData			m_pfGetPortCDatas;
	GetPortBit			m_pfGetPortCBitData;

	SetPortCfg			m_pfSetPortDCfgs;
	SetPortBitCfg		m_pfSetPortDBitCfg;
	SetPortData			m_pfSetPortDDatas;
	SetPortBit			m_pfSetPortDBitData;
	GetPortData			m_pfGetPortDDatas;
	GetPortBit			m_pfGetPortDBitData;

	SetPortCfg			m_pfSetPortECfgs;
	SetPortBitCfg		m_pfSetPortEBitCfg;
	SetPortData			m_pfSetPortEDatas;
	SetPortBit			m_pfSetPortEBitData;
	GetPortData			m_pfGetPortEDatas;
	GetPortBit			m_pfGetPortEBitData;

	SetPortCfg			m_pfSetPortFCfgs;
	SetPortBitCfg		m_pfSetPortFBitCfg;
	SetPortData			m_pfSetPortFDatas;
	SetPortBit			m_pfSetPortFBitData;
	GetPortData			m_pfGetPortFDatas;
	GetPortBit			m_pfGetPortFBitData;

	SetPortCfg			m_pfSetPortGCfgs;
	SetPortBitCfg		m_pfSetPortGBitCfg;
	SetPortData			m_pfSetPortGDatas;
	SetPortBit			m_pfSetPortGBitData;
	GetPortData			m_pfGetPortGDatas;
	GetPortBit			m_pfGetPortGBitData;

	SetPortCfg			m_pfSetPortHCfgs;
	SetPortBitCfg		m_pfSetPortHBitCfg;
	SetPortData			m_pfSetPortHDatas;
	SetPortBit			m_pfSetPortHBitData;
	GetPortData			m_pfGetPortHDatas;
	GetPortBit			m_pfGetPortHBitData;


public:
	CSmartGPIOWrap(void);
	~CSmartGPIOWrap(void);
	// PORT-A  ޼  
	void SetPortABitCfg(int iBitIndex, int iBitCfg);
	bool SetPortACfgs(int iCon);
	void SetPortABit(int iBitIndex, int iBool);
	void SetPortADatas(int iPortData);
	unsigned char GetPortABit(int iBitIndex);
	unsigned char GetPortAData();

	// PORT-B  ޼  
	void SetPortBBitCfg(int iBitIndex, int iBitCfg);
	bool SetPortBCfgs(int iCon);
	void SetPortBBit(int iBitIndex, int iBool);
	void SetPortBDatas(int iPortData);
	unsigned char GetPortBBit(int iBitIndex);
	unsigned char GetPortBData();

	// PORT-C  ޼  
	void SetPortCBitCfg(int iBitIndex, int iBitCfg);
	bool SetPortCCfgs(int iCon);
	void SetPortCBit(int iBitIndex, int iBool);
	void SetPortCDatas(int iPortData);
	unsigned char GetPortCBit(int iBitIndex);
	unsigned char GetPortCData();

	// PORT-D  ޼  
	void SetPortDBitCfg(int iBitIndex, int iBitCfg);
	bool SetPortDCfgs(int iCon);
	void SetPortDBit(int iBitIndex, int iBool);
	void SetPortDDatas(int iPortData);
	unsigned char GetPortDBit(int iBitIndex);
	unsigned char GetPortDData();

	// PORT-E  ޼  
	void SetPortEBitCfg(int iBitIndex, int iBitCfg);
	bool SetPortECfgs(int iCon);
	void SetPortEBit(int iBitIndex, int iBool);
	void SetPortEDatas(int iPortData);
	unsigned char GetPortEBit(int iBitIndex);
	unsigned char GetPortEData();

	// PORT-F  ޼  
	void SetPortFBitCfg(int iBitIndex, int iBitCfg);
	bool SetPortFCfgs(int iCon);
	void SetPortFBit(int iBitIndex, int iBool);
	void SetPortFDatas(int iPortData);
	unsigned char GetPortFBit(int iBitIndex);
	unsigned char GetPortFData();

	// PORT-G  ޼  
	void SetPortGBitCfg(int iBitIndex, int iBitCfg);
	bool SetPortGCfgs(int iCon);
	void SetPortGBit(int iBitIndex, int iBool);
	void SetPortGDatas(int iPortData);
	unsigned char GetPortGBit(int iBitIndex);
	unsigned char GetPortGData();

	// PORT-H  ޼  
	void SetPortHBitCfg(int iBitIndex, int iBitCfg);
	bool SetPortHCfgs(int iCon);
	void SetPortHBit(int iBitIndex, int iBool);
	void SetPortHDatas(int iPortData);
	unsigned char GetPortHBit(int iBitIndex);
	unsigned char GetPortHData();

protected:
	HICON m_hIcon;
	//	DECLARE_MESSAGE_MAP()


};