#pragma once

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Class SmartI2C  C++(EVC++, Visual Studio 2005, 2008 ϵ Wrapping ClassԴϴ.
//  Class ϱ ؼ SmartI2CWrap.h SmartI2CWrap.cpp  Ʈ Ͽ Ͻñ ٶϴ.
//  
// ڼ  SmartX ޴  Ͻñ ٶϴ.
//
// www.hnsts.co.kr
// SmartX copyright(c)2002 All rights reserved by HNS Corp.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

enum EACK 
{
	NOACK = 0,
	ACK   = 1,	
}; 

typedef void (*InitEx)();
typedef void (*SetACKWaitTimeOutEx)(long lInterval);
typedef void (*SetSpeedEx)(long lSpeed);

typedef bool (*StartSignalEx)();
typedef bool (*StopSignalEx)();

typedef unsigned char (*ReadByteEx)(EACK eACK);
typedef bool (*WriteByteEx)(unsigned char uchData);

class CSmartI2CWrap
{
private:

	HINSTANCE				m_hInst;

	InitEx					m_pfInit;
	StartSignalEx			m_pfStartSignal;
	StopSignalEx			m_pfStopSignal;
	ReadByteEx				m_pfReadByte;
	WriteByteEx				m_pfWriteByte;
	SetACKWaitTimeOutEx		m_pfSetACKWaitTimeOut;
	SetSpeedEx				m_pfSetSpeed;

public:
	CSmartI2CWrap(void);
	~CSmartI2CWrap(void);

	void Init();
	void SetACKWaitTimeOut(long lInterval);
	void SetSpeed(long lSpeed);
	bool StartSignal();
	bool StopSignal();
	unsigned char ReadByte(EACK eACK);
	bool WriteByte(unsigned char uchData);

protected:
	HICON m_hIcon;
	//	DECLARE_MESSAGE_MAP()
};