// SmartPWMEVCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SmartPWMEVC.h"
#include "SmartPWMEVCDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSmartPWMEVCDlg dialog

CSmartPWMEVCDlg::CSmartPWMEVCDlg(CWnd* pParent /*=NULL*/)
: CDialog(CSmartPWMEVCDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSmartPWMEVCDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSmartPWMEVCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSmartPWMEVCDlg)
	DDX_Control(pDX, IDC_EDITCARRY2, m_EditCay2);
	DDX_Control(pDX, IDC_EDITPRE, m_EditPre);
	DDX_Control(pDX, IDC_EDITDUTY2, m_EditDuty2);
	DDX_Control(pDX, IDC_EDITDUTY1, m_EditDuty1);
	DDX_Control(pDX, IDC_EDITDEADTIME, m_EditDeadTime);
	DDX_Control(pDX, IDC_EDITCARRY1, m_EditCay1);
	DDX_Control(pDX, IDC_CHKPOL2, m_ChkPol2);
	DDX_Control(pDX, IDC_CHKPOL1, m_ChkPol1);
	DDX_Control(pDX, IDC_CHK28, m_Chk28);
	DDX_Control(pDX, IDC_CHK24, m_Chk24);
	DDX_Control(pDX, IDC_CHK22, m_Chk22);
	DDX_Control(pDX, IDC_CHK216, m_Chk216);
	DDX_Control(pDX, IDC_CHK18, m_Chk18);
	DDX_Control(pDX, IDC_CHK14, m_Chk14);
	DDX_Control(pDX, IDC_CHK12, m_Chk12);
	DDX_Control(pDX, IDC_CHK116, m_Chk116);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSmartPWMEVCDlg, CDialog)
	//{{AFX_MSG_MAP(CSmartPWMEVCDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnCarryInc)
	ON_BN_CLICKED(IDC_BUTTON2, OnCarryDec)
	ON_BN_CLICKED(IDC_BUTTON5, OnDutyInc1)
	ON_BN_CLICKED(IDC_BUTTON6, OnDutyDec1)
	ON_BN_CLICKED(IDC_BUTTON7, OnPreScaleInc)
	ON_BN_CLICKED(IDC_BUTTON8, OnPreScaleDec)
	ON_BN_CLICKED(IDC_BUTTON15, OnDeadTimeInc)
	ON_BN_CLICKED(IDC_BUTTON16, OnDeadTimeDec)
	ON_BN_CLICKED(IDC_BUTTON11, OnCarryInc2)
	ON_BN_CLICKED(IDC_BUTTON12, OnCarryDec2)
	ON_BN_CLICKED(IDC_BUTTON13, OnDutyInc2)
	ON_BN_CLICKED(IDC_BUTTON14, OnDutyDec2)
	ON_BN_CLICKED(IDC_CHK12, OnChk12)
	ON_BN_CLICKED(IDC_CHK14, OnChk14)
	ON_BN_CLICKED(IDC_CHK18, OnChk18)
	ON_BN_CLICKED(IDC_CHK116, OnChk116)
	ON_BN_CLICKED(IDC_CHK22, OnChk22)
	ON_BN_CLICKED(IDC_CHK24, OnChk24)
	ON_BN_CLICKED(IDC_CHK28, OnChk28)
	ON_BN_CLICKED(IDC_CHK216, OnChk216)
	ON_BN_CLICKED(IDC_CHKPOL1, OnChkpol1)
	ON_BN_CLICKED(IDC_CHKPOL2, OnChkpol2)
	ON_BN_CLICKED(IDC_BUTTON4, OnPWM1Start)
	ON_BN_CLICKED(IDC_BUTTON3, OnPWM1Stop)
	ON_BN_CLICKED(IDC_BUTTON10, OnPWM2Start)
	ON_BN_CLICKED(IDC_BUTTON9, OnPWM2Stop)
	ON_BN_CLICKED(IDC_BUTTON18, OnRestore)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSmartPWMEVCDlg message handlers

BOOL CSmartPWMEVCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	// PWM ʱⰪ  
	m_iCarry1 = 200;
	m_Duty1 = 1; //98;

	m_iCarry2 = 200;
	m_Duty2 = 99; //98;

	m_ucDeadTime = 0;

	m_bPWMStart = false;

	// PWM ʱⰪ ȭ  
	CString strTemp;

	strTemp.Format(L"%d", m_iCarry1);
	m_EditCay1.SetWindowText(strTemp); 

	strTemp.Format(L"%d",  m_Duty1);
	m_EditDuty1.SetWindowText(strTemp);

	strTemp.Format(L"%d", m_iCarry2);
	m_EditCay2.SetWindowText(strTemp); 

	strTemp.Format(L"%d", m_Duty2);
	m_EditDuty2.SetWindowText(strTemp);

	m_Chk12.SetCheck(BST_CHECKED);

	m_Chk22.SetCheck(BST_CHECKED);

	strTemp.Format(L"%d", m_ucPreSet);
	m_EditPre.SetWindowText(strTemp);

	strTemp.Format(L"%d",  m_ucDeadTime);
	m_EditDeadTime.SetWindowText(strTemp);

	return TRUE;  // return TRUE  unless you set the focus to a control
}


// PWM1 PWMCounter  1 
void CSmartPWMEVCDlg::OnCarryInc() 
{
	m_iCarry1 = (m_iCarry1 < 1024) ? ++m_iCarry1 : m_iCarry1;

	m_SmartPWM.SetPWMCounter1(m_iCarry1);

	CString strTemp;

	strTemp.Format(L"%d", m_iCarry1);
	m_EditCay1.SetWindowText(strTemp); 
}

// PWM1 PWMCounter  1 
void CSmartPWMEVCDlg::OnCarryDec() 
{
	m_iCarry1 = (m_iCarry1 > 0) ? --m_iCarry1 : m_iCarry1;

	m_SmartPWM.SetPWMCounter1(m_iCarry1);

	CString strTemp;

	strTemp.Format(L"%d", m_iCarry1);
	m_EditCay1.SetWindowText(strTemp); 
}

// PWM1 Duty 1% 
void CSmartPWMEVCDlg::OnDutyInc1() 
{
	CString strTemp;

	m_Duty1 = (m_Duty1 < 1024) ? ++m_Duty1 : m_Duty1;

	m_SmartPWM.SetPWMDutyRate1(m_Duty1);

	strTemp.Format(L"%d",  m_Duty1);

	m_EditDuty1.SetWindowText(strTemp);
}

// PWM1 Duty 1% 
void CSmartPWMEVCDlg::OnDutyDec1() 
{
	CString strTemp;

	m_Duty1 = (m_Duty1 > 0) ? --m_Duty1 : m_Duty1;

	m_SmartPWM.SetPWMDutyRate1(m_Duty1);

	strTemp.Format(L"%d",  m_Duty1);

	m_EditDuty1.SetWindowText(strTemp);
}

// PWM Prescale 1 
void CSmartPWMEVCDlg::OnPreScaleInc() 
{
	CString strTemp;

	m_ucPreSet = (m_ucPreSet < 255) ? ++m_ucPreSet : m_ucPreSet;

	m_SmartPWM.SetPWMPrescaler(m_ucPreSet);

	strTemp.Format(L"%d", m_ucPreSet);

	m_EditPre.SetWindowText(strTemp);
}

// PWM Prescale 1 
void CSmartPWMEVCDlg::OnPreScaleDec() 
{
	CString strTemp;

	m_ucPreSet = (m_ucPreSet > 0) ? --m_ucPreSet : m_ucPreSet;

	m_SmartPWM.SetPWMPrescaler(m_ucPreSet);

	strTemp.Format(L"%d", m_ucPreSet);

	m_EditPre.SetWindowText(strTemp);
}

// PWM DeadTime  1 
void CSmartPWMEVCDlg::OnDeadTimeInc() 
{
	CString strTemp;

	m_ucDeadTime = (m_ucDeadTime < 255) ? ++m_ucDeadTime : m_ucDeadTime;

	m_SmartPWM.SetPWMDeadTime(m_ucDeadTime);

	strTemp.Format(L"%d",  m_ucDeadTime);

	m_EditDeadTime.SetWindowText(strTemp);
}

// PWM DeadTime  1 
void CSmartPWMEVCDlg::OnDeadTimeDec() 
{
	CString strTemp;

	m_ucDeadTime = (m_ucDeadTime > 0) ? --m_ucDeadTime : m_ucDeadTime;

	m_SmartPWM.SetPWMDeadTime(m_ucDeadTime);

	strTemp.Format(L"%d",  m_ucDeadTime);

	m_EditDeadTime.SetWindowText(strTemp);
}

// PWM2 PWMCounter  1 
void CSmartPWMEVCDlg::OnCarryInc2() 
{
	m_iCarry2 = (m_iCarry2 < 1024) ? ++m_iCarry2 : m_iCarry2;

	m_SmartPWM.SetPWMCounter2(m_iCarry2);

	CString strTemp;

	strTemp.Format(L"%d", m_iCarry2);
	m_EditCay2.SetWindowText(strTemp); 
}

// PWM2 PWMCounter  1 
void CSmartPWMEVCDlg::OnCarryDec2() 
{
	m_iCarry2 = (m_iCarry2 > 0) ? --m_iCarry2 : m_iCarry2;

	m_SmartPWM.SetPWMCounter2(m_iCarry2);

	CString strTemp;

	strTemp.Format(L"%d", m_iCarry2);
	m_EditCay2.SetWindowText(strTemp); 
}

// PWM2 Duty 1% 
void CSmartPWMEVCDlg::OnDutyInc2() 
{
	CString strTemp;

	m_Duty2 = (m_Duty2 < 1024) ? ++m_Duty2 : m_Duty2;

	m_SmartPWM.SetPWMDutyRate2(m_Duty2);

	strTemp.Format(L"%d", m_Duty2);

	m_EditDuty2.SetWindowText(strTemp);
}

// PWM2 Duty 1% 
void CSmartPWMEVCDlg::OnDutyDec2() 
{
	CString strTemp;

	m_Duty2 = (m_Duty2 > 0) ? --m_Duty2 : m_Duty2;

	m_SmartPWM.SetPWMDutyRate2(m_Duty2);

	strTemp.Format(L"%d",  m_Duty2);

	m_EditDuty2.SetWindowText(strTemp);
}

// PWM1  Ŭ (̴)  
void CSmartPWMEVCDlg::OnChk12() 
{
	m_Chk14.SetCheck(BST_UNCHECKED);
	m_Chk18.SetCheck(BST_UNCHECKED);
	m_Chk116.SetCheck(BST_UNCHECKED);

	m_SmartPWM.SetPWMClkDivider1(0); 
}

// PWM1  Ŭ (̴)  
void CSmartPWMEVCDlg::OnChk14() 
{
	m_Chk12.SetCheck(BST_UNCHECKED);
	m_Chk18.SetCheck(BST_UNCHECKED);
	m_Chk116.SetCheck(BST_UNCHECKED);

	m_SmartPWM.SetPWMClkDivider1(1); 
}

// PWM1  Ŭ (̴)  
void CSmartPWMEVCDlg::OnChk18() 
{
	m_Chk12.SetCheck(BST_UNCHECKED);
	m_Chk14.SetCheck(BST_UNCHECKED);
	m_Chk116.SetCheck(BST_UNCHECKED);

	m_SmartPWM.SetPWMClkDivider1(2);
}

// PWM1  Ŭ (̴)  
void CSmartPWMEVCDlg::OnChk116() 
{
	m_Chk12.SetCheck(BST_UNCHECKED);
	m_Chk14.SetCheck(BST_UNCHECKED);
	m_Chk18.SetCheck(BST_UNCHECKED);

	m_SmartPWM.SetPWMClkDivider1(3);
}

// PWM2  Ŭ (̴)  
void CSmartPWMEVCDlg::OnChk22() 
{
	m_Chk24.SetCheck(BST_UNCHECKED);
	m_Chk28.SetCheck(BST_UNCHECKED);
	m_Chk216.SetCheck(BST_UNCHECKED);

	m_SmartPWM.SetPWMClkDivider2(0);
}

// PWM2  Ŭ (̴)  
void CSmartPWMEVCDlg::OnChk24() 
{
	m_Chk22.SetCheck(BST_UNCHECKED);
	m_Chk28.SetCheck(BST_UNCHECKED);
	m_Chk216.SetCheck(BST_UNCHECKED);

	m_SmartPWM.SetPWMClkDivider2(1);
}

// PWM2  Ŭ (̴)  
void CSmartPWMEVCDlg::OnChk28() 
{
	m_Chk22.SetCheck(BST_UNCHECKED);
	m_Chk24.SetCheck(BST_UNCHECKED);
	m_Chk216.SetCheck(BST_UNCHECKED);

	m_SmartPWM.SetPWMClkDivider2(2);
}

// PWM2  Ŭ (̴)  
void CSmartPWMEVCDlg::OnChk216() 
{
	m_Chk22.SetCheck(BST_UNCHECKED);
	m_Chk24.SetCheck(BST_UNCHECKED);
	m_Chk28.SetCheck(BST_UNCHECKED);

	m_SmartPWM.SetPWMClkDivider2(3);
}

// PWM1  ؼ (Hight Active Or Low Active) 
void CSmartPWMEVCDlg::OnChkpol1() 
{
	if(m_ChkPol1.GetCheck() == BST_CHECKED)
	{
		m_SmartPWM.SetPWMPolarity1(true);
	}
	else
	{
		m_SmartPWM.SetPWMPolarity1(false);
	}
}

// PWM2  ؼ (Hight Active Or Low Active) 
void CSmartPWMEVCDlg::OnChkpol2() 
{
	if(m_ChkPol2.GetCheck() == BST_CHECKED)
	{
		m_SmartPWM.SetPWMPolarity2(true);
	}
	else
	{
		m_SmartPWM.SetPWMPolarity2(false);
	}
}

// PWM1  · PWM1   
void CSmartPWMEVCDlg::OnPWM1Start() 
{
	m_bPWMStart = true;

	// PWM1  PWM Ķ  
	m_SmartPWM.SetPWMCounter1(m_iCarry1);
	m_SmartPWM.SetPWMDutyRate1(m_Duty1);
	m_SmartPWM.SetPWMPrescaler(m_ucPreSet);
	m_SmartPWM.SetPWMDeadTime(m_ucDeadTime);
	m_SmartPWM.SetPWMClkDivider1(0);
	m_SmartPWM.Start_PWM1();
}

// PWM1    
void CSmartPWMEVCDlg::OnPWM1Stop() 
{
	m_SmartPWM.Stop_PWM1();

	m_bPWMStart = false;
}

// PWM2  · PWM1   
void CSmartPWMEVCDlg::OnPWM2Start() 
{
	m_bPWMStart = true;

	// PWM2  PWM Ķ  
	m_SmartPWM.SetPWMCounter2(m_iCarry1);
	m_SmartPWM.SetPWMDutyRate2(m_Duty1);
	m_SmartPWM.SetPWMPrescaler(m_ucPreSet);
	m_SmartPWM.SetPWMDeadTime(m_ucDeadTime);	
	m_SmartPWM.SetPWMClkDivider2(0);
	m_SmartPWM.Start_PWM2();
}

// PWM2    
void CSmartPWMEVCDlg::OnPWM2Stop() 
{
	m_bPWMStart = false;

	m_SmartPWM.Stop_PWM2();
}

// PWM  ϱؼ  ͸  մϴ.
void CSmartPWMEVCDlg::OnRestore() 
{
	m_SmartPWM.PWMRestore();
}

void CSmartPWMEVCDlg::OnClose() 
{
	//  Ǳ PWM  ϱؼ  ͸  մϴ.
	if(m_bPWMStart == true)
	{
		m_SmartPWM.PWMRestore();
	}

	CDialog::OnClose();
}
