#pragma once

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Class SmartPWM  C++(EVC++, Visual Studio 2005, 2008 ϵ Wrapping ClassԴϴ.
//  Class ϱ ؼ SmartPWMWrap.h SmartPWMWrap.cpp  Ʈ Ͽ Ͻñ ٶϴ.
//  
// ڼ  SmartX ޴  Ͻñ ٶϴ.
//
// www.hnsts.co.kr
// SmartX copyright(c)2002 All rights reserved by HNS Corp.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
typedef unsigned long       DWORD;

typedef void (*SetPWMPrescalerEx)(unsigned char ucPrescaler);

typedef void (*SetPWMClkDivider1Ex)(unsigned char ucClkDivider1);
typedef void (*SetPWMClkDivider2Ex)(unsigned char ucClkDivider2);

typedef void (*SetPWMCounter1Ex)(unsigned int uiPwmCounter1);
typedef void (*SetPWMCounter2Ex)(unsigned int uiPwmCounter2);

typedef void (*SetPWMDeadTimeEx)(unsigned char ucDeadTime);

typedef void (*SetPWMPolarity1Ex)(bool bPolarity1);
typedef void (*SetPWMPolarity2Ex)(bool bPolarity2);

typedef void (*SetPWMCarryFreq1Ex)(unsigned char ucPreScaler, unsigned char ucDivider, unsigned int uiPWMCounter);
typedef void (*SetPWMCarryFreq2Ex)(unsigned char ucPreScaler, unsigned char ucDivider, unsigned int uiPWMCounter);

typedef void (*SetPWMDutyRate1Ex)(double dDutyRate1);
typedef void (*SetPWMDutyRate2Ex)(double dDutyRate2);

typedef void (*Start_PWM1Ex)();
typedef void (*Start_PWM2Ex)();

typedef void (*Stop_PWM1Ex)();
typedef void (*Stop_PWM2Ex)();

typedef void (*PWMRestoreEx)();

class CSmartPWMWrap
{
private:

	HINSTANCE			m_hInst;
	
	SetPWMPrescalerEx		m_pfSetPWMPrescaler;
	
	SetPWMClkDivider1Ex		m_pfSetPWMClkDivider1;
	SetPWMClkDivider2Ex		m_pfSetPWMClkDivider2;
	
	SetPWMCounter1Ex		m_pfSetPWMCounter1;
	SetPWMCounter2Ex		m_pfSetPWMCounter2;

	SetPWMDeadTimeEx		m_pfSetPWMDeadTime;

	SetPWMPolarity1Ex		m_pfSetPWMPolarity1;
	SetPWMPolarity2Ex		m_pfSetPWMPolarity2;

	SetPWMCarryFreq1Ex		m_pfSetPWMCarryFreq1;
	SetPWMCarryFreq2Ex		m_pfSetPWMCarryFreq2;

	SetPWMDutyRate1Ex		m_pfSetPWMDutyRate1;
	SetPWMDutyRate2Ex		m_pfSetPWMDutyRate2;

	Start_PWM1Ex			m_pfStart_PWM1;
	Start_PWM2Ex		m_pfStart_PWM2;

	Stop_PWM1Ex			m_pfStop_PWM1;
	Stop_PWM2Ex			m_pfStop_PWM2;

	PWMRestoreEx		m_pfPWMRestore;

public:
	CSmartPWMWrap(void);
	~CSmartPWMWrap(void);

	void SetPWMPrescaler(unsigned char ucPrescaler);
	void SetPWMClkDivider1(unsigned char ucClkDivider1);
	void SetPWMClkDivider2(unsigned char ucClkDivider2);
	void SetPWMCounter1(unsigned int uiPwmCounter1);
	void SetPWMCounter2(unsigned int uiPwmCounter2);
	void SetPWMDeadTime(unsigned char ucDeadTime);
	void SetPWMPolarity1(bool bPolarity1);
	void SetPWMPolarity2(bool bPolarity2);
	void SetPWMCarryFreq1(unsigned char ucPreScaler, unsigned char ucDivider, unsigned int uiPWMCounter);
	void SetPWMCarryFreq2(unsigned char ucPreScaler, unsigned char ucDivider, unsigned int uiPWMCounter);
	void SetPWMDutyRate1(double dDutyRate1);
	void SetPWMDutyRate2(double dDutyRate2);
	void Start_PWM1();
	void Start_PWM2();
	void Stop_PWM1();
	void Stop_PWM2();
	void PWMRestore();

protected:
	HICON m_hIcon;
//	DECLARE_MESSAGE_MAP()


};