// SmartPlayEVCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SmartPlayEVC.h"
#include "SmartPlayEVCDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CSmartPlayEVCDlg ȭ

CSmartPlayEVCDlg::CSmartPlayEVCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSmartPlayEVCDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSmartPlayEVCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LABPALYFILE, m_LabPalyFile);
	DDX_Control(pDX, IDC_LABPOS, m_LabPos);
	DDX_Control(pDX, IDC_LABVOL, m_LabVol);
	DDX_Control(pDX, IDC_VIEW, m_View);
	DDX_Control(pDX, IDC_SLIDER1, m_SliderPos);
}

BEGIN_MESSAGE_MAP(CSmartPlayEVCDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTFILE, &CSmartPlayEVCDlg::OnBnClickedButfile)
	ON_BN_CLICKED(IDC_BUTPLAY, &CSmartPlayEVCDlg::OnBnClickedButplay)
	ON_BN_CLICKED(IDC_BUTSTOP, &CSmartPlayEVCDlg::OnBnClickedButstop)
	ON_BN_CLICKED(IDC_BUTPAUSE, &CSmartPlayEVCDlg::OnBnClickedButpause)
	ON_BN_CLICKED(IDC_BUTVOLUP, &CSmartPlayEVCDlg::OnBnClickedButvolup)
	ON_BN_CLICKED(IDC_BUTVOLDOWN, &CSmartPlayEVCDlg::OnBnClickedButvoldown)
	ON_WM_TIMER()
	ON_WM_HSCROLL()
	ON_WM_DESTROY()
	ON_STN_CLICKED(IDC_VIEW, &CSmartPlayEVCDlg::OnStnClickedView)
	ON_BN_CLICKED(IDC_BUTMAX, &CSmartPlayEVCDlg::OnBnClickedButmax)
END_MESSAGE_MAP()


// CSmartPlayEVCDlg ޽ó

BOOL CSmartPlayEVCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̴ȭ  մϴ. α׷ â ȭڰ ƴҰ쿡
	//  ӿũ  ۾ ڵ մϴ.
	SetIcon(m_hIcon, TRUE);			// ū  մϴ.
	SetIcon(m_hIcon, FALSE);		//   մϴ.

	// View Control Click Event ޱ ó
	m_View.ModifyStyle(0, SS_NOTIFY);

	// SmartPlayer DLL Load  Ȯ
	if(m_SmartPlay.IsLoadDll() == true)
	{
		// Load   ʱȭ ó  Ÿ̸ 
		SetTimer(7, 1000, NULL); 
	}
	return TRUE;  // Ŀ Ʈѿ   TRUE ȯմϴ.
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CSmartPlayEVCDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_SMARTPLAYEVC_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_SMARTPLAYEVC_DIALOG));
	}
}
#endif


//     Open ó 
void CSmartPlayEVCDlg::OnBnClickedButfile()
{
	CFileDialog opDlg(TRUE);

	if(opDlg.DoModal() == IDOK)
	{
		// õ  ι ̸ 
		m_strPlayFile = opDlg.GetPathName();
		m_LabPalyFile.SetWindowTextW(m_strPlayFile);

		// ȭ ũ 
		m_View.MoveWindow(15, 1, 680, 320);

		// õ   Open óմϴ.
		m_SmartPlay.Open(m_strPlayFile.GetBuffer(), 680, 320);

		//  ġ  Trackbar 
		m_SliderPos.SetRange(0, m_SmartPlay.GetMaxPos());
		m_SliderPos.SetPos(0);
	}
 
}

// Open   Play ó
void CSmartPlayEVCDlg::OnBnClickedButplay()
{
	m_SmartPlay.Play();

	//  Play  Seek  TrackBar Update ó Ÿ̸ 
	SetTimer(3, 500, NULL); 
}

// Play    ó 
void CSmartPlayEVCDlg::OnBnClickedButstop()
{
	m_SmartPlay.Stop();
}

// Play   Ͻ  ó 
void CSmartPlayEVCDlg::OnBnClickedButpause()
{
	m_SmartPlay.Pause();
}

// Ҹ ũ 
void CSmartPlayEVCDlg::OnBnClickedButvolup()
{
	m_SmartPlay.SetVolume(m_SmartPlay.GetVolume() + 1000);

	CString strMsg;
	strMsg.Format(L"%ld", m_SmartPlay.GetVolume());
	m_LabVol.SetWindowTextW(strMsg);
}

// Ҹ ũ 
void CSmartPlayEVCDlg::OnBnClickedButvoldown()
{
	m_SmartPlay.SetVolume(m_SmartPlay.GetVolume() - 1000);

	CString strMsg;
	strMsg.Format(L"%ld", m_SmartPlay.GetVolume());
	m_LabVol.SetWindowTextW(strMsg);
}

void CSmartPlayEVCDlg::OnTimer(UINT_PTR nIDEvent)
{
	if(nIDEvent == 3)
	{
		//   ġ  ̸ ȭ ǥ ó
		CString strMsg;
		strMsg.Format(L"[%ld / %ld]", m_SmartPlay.GetCurrentPos(), m_SmartPlay.GetMaxPos());
		m_LabPos.SetWindowTextW(strMsg);
		m_SliderPos.SetPos(m_SmartPlay.GetCurrentPos());
	}

	if(nIDEvent == 7)
	{
		// α׷   1ȸ ȴ.
		//  ȭ Handle 
		m_SmartPlay.SetPreviewWindowHandle(m_View.m_hWnd);
		//    ʱȭ ó
		m_SmartPlay.Initialization();
		//  1ȸ ϵ ó
		KillTimer(7);
	}

	CDialog::OnTimer(nIDEvent);
}

void CSmartPlayEVCDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// SliderBar Scroll Event Filltering ó 
	if (pScrollBar == (CScrollBar*)&m_SliderPos) 
	{  
		//   ġ 缳
		m_SmartPlay.SetCurrentPos(m_SliderPos.GetPos());
	}  

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CSmartPlayEVCDlg::OnDestroy()
{
	CDialog::OnDestroy();

	m_SmartPlay.Stop();
}


//  ȭ  ü ȭ ¿ ȭ Double Click    ȭũ  
void CSmartPlayEVCDlg::OnStnClickedView()
{
	m_SmartPlay.ViewFullSize(false);
}

// üȭ 
void CSmartPlayEVCDlg::OnBnClickedButmax()
{
	m_SmartPlay.ViewFullSize(true);
}