// SmartPlayEVCDlg.h : header file
//

#pragma once
#include "smartplaywrap.h"
#include "afxwin.h"
#include "afxcmn.h"

// CSmartPlayEVCDlg dialog
class CSmartPlayEVCDlg : public CDialog
{
// Construction
public:
	CSmartPlayEVCDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_SMARTPLAYEVC_DIALOG };


private:
	CString	m_strPlayFile;
	CSmartPlayWrap m_SmartPlay;


	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	afx_msg void OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/);
#endif
	DECLARE_MESSAGE_MAP()
private:
	CStatic m_View;
public:
	afx_msg void OnBnClickedButfile();
private:
	CStatic m_LabPalyFile;
public:
	CSliderCtrl m_SliderPos;
	afx_msg void OnBnClickedButplay();
	afx_msg void OnBnClickedButstop();
	afx_msg void OnBnClickedButpause();
	afx_msg void OnBnClickedButvolup();
	afx_msg void OnBnClickedButvoldown();
private:
	CStatic m_LabVol;
public:
	afx_msg void OnTimer(UINT_PTR nIDEvent);
private:
	CStatic m_LabPos;
public:
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnDestroy();
	afx_msg void OnBnClickedButmax();
	afx_msg void OnStnClickedView();
};
