///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Class SmartPlayer  C++(EVC++, Visual Studio 2005, 2008) ϵ Wrapping ClassԴϴ.
//  Class ϱ ؼ SmartPlayWrap.h SmartPlayWrap.cpp  Ʈ Ͽ Ͻñ ٶϴ.
//    Ե "DLL\SmartPlayCore.dll" Ǵ ϰ   Ͽ Ͻñ ٶϴ.
//  
// ڼ  SmartX ޴  Ͻñ ٶϴ.
//
// SmartX copyright(c)2008 All rights reserved by HNS Corp.   www.hnsts.co.kr
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#pragma once

typedef void (*InitializationEx)();
typedef void (*SetPreviewWindowHandleEx)(HWND hPreviewWindow);
typedef bool (*OpenEx)(LPTSTR strFilePathName);
typedef bool (*OpenEx1)(LPTSTR strFilePathName, long lWidth, long lHeight);
typedef bool (*PlayEx)();

typedef bool  (*StopEx)();
typedef bool  (*PauseEx)();
typedef bool  (*IsCompleteEx)();
typedef DWORD  (*GetCurrentPosEx)();
typedef DWORD  (*GetMaxPosEx)();
typedef bool  (*SetCurrentPosEx)(DWORD dwPos);
typedef long  (*GetVolumeEx)();
typedef bool  (*SetVolumeEx)(long lVol);
typedef bool  (*ViewFullSizeEx)(bool bMode);


class CSmartPlayWrap
{
private:
	HINSTANCE						m_hInst;

	InitializationEx				m_pfInitialization;
	SetPreviewWindowHandleEx		m_pfSetPreviewWindowHandle;
	OpenEx							m_pfOpen;
	OpenEx1							m_pfOpen1;
	PlayEx							m_pfPlay;
	StopEx							m_pfStop;
	PauseEx							m_pfPause;
	IsCompleteEx					m_pfIsComplete;
	GetCurrentPosEx					m_pfGetCurrentPos;
	GetMaxPosEx						m_pfGetMaxPos;
	SetCurrentPosEx					m_pfSetCurrentPos;
	GetVolumeEx						m_pfGetVolume;
	SetVolumeEx						m_pfSetVolume;
	ViewFullSizeEx					m_pfViewFullSize;

public:
	CSmartPlayWrap(void);
	~CSmartPlayWrap(void);

	bool							IsLoadDll();
	void							Initialization(void);
	void							SetPreviewWindowHandle(HWND hPreviewWindow);
	bool							Open(WCHAR* strFilePathName);
	bool							Open(WCHAR* strFilePathName, long lWidth, long lHeight);
	bool							Play(void);
	bool							Stop(void);
	bool							Pause(void);
	bool							IsComplete();

	DWORD							GetCurrentPos();
	DWORD							GetMaxPos();
	bool							SetCurrentPos(DWORD dwPos);

	long							GetVolume();
	bool							SetVolume(long lVol);

	bool							ViewFullSize(bool bMode);
};
