///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Class SmartSound  C++(EVC++, Visual Studio 2005, 2008) ϵ Wrapping ClassԴϴ.
//  Class ϱ ؼ SmartSoundWrap.h SmartSoundWrap.cpp  Ʈ Ͽ Ͻñ ٶϴ.
//    Ե "DLL\IEC667HWCON.dll" Ǵ ϰ   Ͽ Ͻñ ٶϴ.
//  
// ڼ  SmartX ޴  Ͻñ ٶϴ.
//
// SmartX copyright(c)2002 All rights reserved by HNS Corp.   www.hnsts.co.kr
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SmartSoundWrap.h"

CSmartSoundWrap::CSmartSoundWrap(void)
{
	m_hInst = LoadLibrary(L"IEC667HWCON.dll");

	if(m_hInst == NULL)
	{
		return;
	}

	m_pfSetPlayFilePath = (SetPlayFilePathEx)GetProcAddress(m_hInst, _T("SetPlayFilePath"));
	m_pfPlay_Sound = (Play_SoundEx)GetProcAddress(m_hInst, _T("Play_Sound"));
	m_pfPause_Sound = (Pause_SoundEx)GetProcAddress(m_hInst, _T("Pause_Sound"));
	m_pfStop_Sound = (Stop_SoundEx)GetProcAddress(m_hInst, _T("Stop_Sound"));
	m_pfGetVolume = (GetVolumeEx)GetProcAddress(m_hInst, _T("GetVolume"));
	m_pfSetVolume = (SetVolumeEx)GetProcAddress(m_hInst, _T("SetVolume"));
	m_pfIsPlay = (Is_Play)GetProcAddress(m_hInst, _T("Is_Play"));
}

CSmartSoundWrap::~CSmartSoundWrap(void)
{
	FreeLibrary(m_hInst);
}

// ÷   θ ڿ 
void CSmartSoundWrap::SetPlayFilePath(LPTSTR strPath)
{
	m_pfSetPlayFilePath(strPath);
}

// SetPlayFilePath()   ÷
bool CSmartSoundWrap::Play_Sound()
{
	return m_pfPlay_Sound();
}

//   ÷߿ ִ  ÷̸  ߴ
bool CSmartSoundWrap::Pause_Sound()
{
	return m_pfPause_Sound();
}

// ÷ ̸ ָ 
bool CSmartSoundWrap::Stop_Sound()
{
	return m_pfStop_Sound();
}

// IEC_Series   
DWORD CSmartSoundWrap::GetVolume()
{
	return m_pfGetVolume();
}

// IEC_Series   
void CSmartSoundWrap::SetVolume(DWORD dwVol)
{
	m_pfSetVolume(dwVol);
}

//    ȮѴ.
// true : 
// false :  ƴ
bool CSmartSoundWrap::IsPlay()
{
	return m_pfIsPlay();
}
