///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Class SmartUpdate  C++(EVC++, Visual Studio 2005, 2008) ϵ Wrapping ClassԴϴ.
//  Class ϱ ؼ SmartUpdateWrap.h SmartUpdateWrap.cpp  Ʈ Ͽ Ͻñ ٶϴ.
//    Ե "DLL\SmartUpDate.dll" Ǵ ϰ   Ͽ Ͻñ ٶϴ.
//  
// ڼ  SmartX ޴  Ͻñ ٶϴ.
//
// SmartX copyright(c)2002 All rights reserved by HNS Corp.   www.hnsts.co.kr
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#pragma once


typedef void (*SetPathEx)(LPWSTR strFromFile, LPWSTR strToFile);
typedef void (*SetBackImagePathEx)(LPWSTR strImgFilePath);
typedef void (*SetDisplayTextEx)(LPWSTR strTitle, LPWSTR strMessage, LPWSTR strCompanyName);
typedef void (*SetDisplayTextColorEx)(DWORD dwTitelColor, DWORD dwMsgColor, DWORD dwCompanyColor);
typedef void (*SetStartIntervalEx)(DWORD dwInterval);
typedef void (*SetRebootEx)(int iReboot);
typedef BOOL (*StartEx)();



class CSmartUpdateWrap
{
private:
	HINSTANCE				m_hInst;

	SetPathEx				m_pfSetPath;
	SetBackImagePathEx		m_pfSetBackImagePath;
	SetDisplayTextEx		m_pfSetDisplayText;
	SetDisplayTextColorEx	m_pfSetDisplayTextColor;
	SetStartIntervalEx		m_pfSetStartInterval;
	SetRebootEx				m_pfSetReboot;
	StartEx					m_pfStart;

public:
	CSmartUpdateWrap(void);
	~CSmartUpdateWrap(void);

	void SetPath(LPWSTR strFromFile, LPWSTR strToFile);
	void SetBackImagePath(LPWSTR strImgFilePath);
	void SetDisplayText(LPWSTR strTitle, LPWSTR strMessage, LPWSTR strCompanyName);
	void SetDisplayTextColor(COLORREF crTitelColor, COLORREF crMsgColor, COLORREF crCompanyColor);
	void SetStartInterval(DWORD dwInterval);
	void SetReboot(int iReboot);
	BOOL Start();
};
