///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Class SmartVideo  C++(EVC++, Visual Studio 2005, 2008) ϵ Wrapping ClassԴϴ.
//  Class ϱ ؼ SmartVideoCoreWrap.h SmartVideoCoreWrap.cpp  Ʈ Ͽ Ͻñ ٶϴ.
//    Ե "DLL\SmartVideoCoreDll.dll" Ǵ ϰ   Ͽ Ͻñ ٶϴ.
//  
// ڼ  SmartX ޴  Ͻñ ٶϴ.
//
// SmartX copyright(c)2008 All rights reserved by HNS Corp.   www.hnsts.co.kr
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "SmartVideoCoreWrap.h"

CSmartVideoCoreWrap::CSmartVideoCoreWrap(void)
{
	m_hInst = LoadLibrary(L"SmartVideoCoreDll.dll");

    if(m_hInst == NULL)
	{
        return;
	}


	// ̽ ȹ  (̽ νϽ óѴ.)
	m_pfInitialization = (InitializationEx)GetProcAddress(m_hInst, _T("Initialization"));
	m_pfSetPreviewWindowHandle = (SetPreviewWindowHandleEx)GetProcAddress(m_hInst, _T("SetPreviewWindowHandle"));
	m_pfPlay = (PlayEx)GetProcAddress(m_hInst, _T("Play"));
	m_pfStop = (StopEx)GetProcAddress(m_hInst, _T("Stop"));
	m_pfSetPreviewResolution = (SetPreviewResolutionEx)GetProcAddress(m_hInst, _T("SetPreviewResolution"));
	m_pfGetPreviewResolution = (GetPreviewResolutionEx)GetProcAddress(m_hInst, _T("GetPreviewResolution"));
	m_pfSetCaptureResolution = (SetCaptureResolutionEx)GetProcAddress(m_hInst, _T("SetCaptureResolution"));
	m_pfGetCaptureResolution = (GetCaptureResolutionEx)GetProcAddress(m_hInst, _T("GetCaptureResolution"));
	m_pfImageMemoryCapture = (ImageMemoryCaptureEx)GetProcAddress(m_hInst, _T("ImageMemoryCapture"));
	m_pfCaptureStillImage = (CaptureStillImageEx)GetProcAddress(m_hInst, _T("CaptureStillImage"));
	m_pfSetEncodingParameter1 = (SetEncodingParameter1Ex)GetProcAddress(m_hInst, _T("SetEncodingParameter1"));
	m_pfSetEncodingParameter2 = (SetEncodingParameter2Ex)GetProcAddress(m_hInst, _T("SetEncodingParameter2"));
	m_pfInitEncoding = (InitEncodingEx)GetProcAddress(m_hInst, _T("InitEncoding"));
	m_pfRunEncoding = (RunEncodingEx)GetProcAddress(m_hInst, _T("RunEncoding"));
	m_pfEndEncoding = (EndEncodingEx)GetProcAddress(m_hInst, _T("EndEncoding"));
	m_pfStopEncoding = (StopEncodingEx)GetProcAddress(m_hInst, _T("StopEncoding"));
	m_pfSetSourceChannel = (SetSourceChannelEx)GetProcAddress(m_hInst, _T("SetSourceChannel"));
	m_pfSetBrightnessControl = (SetBrightnessControlEx)GetProcAddress(m_hInst, _T("SetBrightnessControl"));
	m_pfSetHueControl = (SetHueControlEx)GetProcAddress(m_hInst, _T("SetHueControl"));
	m_pfSetContrastControl = (SetContrastControlEx)GetProcAddress(m_hInst, _T("SetContrastControl"));
	m_pfSetColorSaturationControl = (SetColorSaturationControlEx)GetProcAddress(m_hInst, _T("SetColorSaturationControl"));
	m_pfSetDefaultControl = (SetDefaultControlEx)GetProcAddress(m_hInst, _T("SetDefaultControl"));

}

CSmartVideoCoreWrap::~CSmartVideoCoreWrap(void)
{
	FreeLibrary(m_hInst);
}

// SmartVideo ϱ  ʱȭ Լ 
//  : Preview ȭ μ ػ󵵸  մϴ.
//   : true -> , false -> 
bool CSmartVideoCoreWrap::Initialization(int iPreviewResolution)
{
	return m_pfInitialization(iPreviewResolution);
}

// Preview â  WindowǴ Ʈ ڵ  մϴ.
void CSmartVideoCoreWrap::SetPreviewWindowHandle(HWND hPreviewWindow)
{
	m_pfSetPreviewWindowHandle(hPreviewWindow);
}

// Preview  
//   : true -> , false -> 
bool CSmartVideoCoreWrap::Play()
{
	return m_pfPlay();
}
// Preview  
//   : true -> , false -> 
bool CSmartVideoCoreWrap::Stop()
{
	return m_pfStop();
}
 
// Preview ػ 
//  :  0 -> 160 * 96, 1 -> 192 * 144, 2 -> 240 * 144, 3 -> 256 * 192, 4 -> 320 * 192
//		   5 -> 320 * 240, 6 -> 380 * 228, 7 -> 448 * 336, 8 -> 480 * 288, 9 -> 512 * 384
//         10 -> 560 * 336, 11 -> 576 * 432, 12 -> 640 * 384, 13 -> 640 * 480, 14 -> 720 * 480
//         15 -> 800 * 480, 16 -> 800 * 600  
//   : true -> , false -> 	
bool CSmartVideoCoreWrap::SetPreviewResolution(int iPreviewResolution)
{
	return m_pfSetPreviewResolution(iPreviewResolution);
}
//   Preview , ػ󵵸 ´
//  : pWidth ->  ػ  , pHeight ->  ػ  
void CSmartVideoCoreWrap::GetPreviewResolution(int* pWidth, int* pHeight)
{
	m_pfGetPreviewResolution(pWidth, pHeight);
}

//     ػ 
//  :  0 -> 160 * 96, 1 -> 192 * 144, 2 -> 240 * 144, 3 -> 256 * 192, 4 -> 320 * 192
//		   5 -> 320 * 240, 6 -> 448 * 336, 7 -> 480 * 288, 8 -> 560 * 336, 9 -> 576 * 432
//         10 -> 640 * 384, 11 -> 640 * 480, 12 -> 720 * 480
//   : true -> , false -> 
bool CSmartVideoCoreWrap::SetCaptureResolution(int iCaptureResolution)
{
	return m_pfSetCaptureResolution(iCaptureResolution);
}
//       ػ , ػ󵵸 ´
//  : pWidth ->  ػ  , pHeight ->  ػ  
void CSmartVideoCoreWrap::GetCaptureResolution(int* pWidth, int* pHeight)
{
	m_pfGetCaptureResolution(pWidth, pHeight);
}

//  ޸𸮿 ´.
//  :   ޸  
//          ػ󵵸  ʿ ũ ޸ Ҵ · Ұ 
//   : true -> , false -> 
bool CSmartVideoCoreWrap::ImageMemoryCapture(unsigned char* pRawByte)
{
	return m_pfImageMemoryCapture(pRawByte);
}
//   Ϸ մϴ.
//  :  ι ̸   GIF, PNG, BMP, JPG
//   : true -> , false -> 
bool CSmartVideoCoreWrap::CaptureStillImage(LPTSTR strImgPathName)
{
	return m_pfCaptureStillImage(strImgPathName);
}

//  ϱ  ĸͰ մϴ.
//  : strOutFilePathName ->   ι ̸, iframe_rate -> ӷƮ, ibitrate -> Ʈ Ʈ
void CSmartVideoCoreWrap::SetEncodingParameter1(LPTSTR strOutFilePathName, unsigned int iframe_rate, unsigned int ibitrate)
{
	m_pfSetEncodingParameter1(strOutFilePathName, iframe_rate, ibitrate);
}
//  ϱ  ĸͰ մϴ.
//  : igop_num ->   , iIntraqp ->   , iqpmax ->   , fgamma -> 
void CSmartVideoCoreWrap::SetEncodingParameter2(unsigned int igop_num, unsigned int iIntraqp, unsigned int iqpmax, float fgamma)
{
	m_pfSetEncodingParameter2(igop_num, iIntraqp, iqpmax, fgamma);
}

//    ʱȭ
//   : true -> , false -> 
bool CSmartVideoCoreWrap::InitEncoding()
{
	return m_pfInitEncoding();
}
//   
//   : true -> , false -> 
bool CSmartVideoCoreWrap::RunEncoding()
{
	return m_pfRunEncoding();
}
//   
//   : true -> , false -> 
bool CSmartVideoCoreWrap::EndEncoding()
{
	return m_pfEndEncoding();
}
//    
//   : true -> , false -> 
bool CSmartVideoCoreWrap::StopEncoding()
{
	return m_pfStopEncoding();
}

//  Է ä  (1~4)
//  : 1 -> 1channel, 2 -> 2channel, 3 -> 3channel, 4 -> 4channel
void CSmartVideoCoreWrap::SetSourceChannel(int iChannel)
{
	m_pfSetSourceChannel(iChannel);
}

//   
//  : 0 ~ 255,(ʱ ⺻ : 128)
void CSmartVideoCoreWrap::SetBrightnessControl(int iBrightness)
{
	m_pfSetBrightnessControl(iBrightness);
}
//   
//  : 0 ~ 255,(ʱ ⺻ : 0)
void CSmartVideoCoreWrap::SetHueControl(int iHue)
{
	m_pfSetHueControl(iHue);
}
//   
//  : 0 ~ 255,(ʱ ⺻ : 128)
void CSmartVideoCoreWrap::SetContrastControl(int iContrast)
{
	m_pfSetContrastControl(iContrast);
}
//  ä 
//  : 0 ~ 255,(ʱ ⺻ : 128)
void CSmartVideoCoreWrap::SetColorSaturationControl(int iColorSaturation)
{
	m_pfSetColorSaturationControl(iColorSaturation);
}
//  Ӽ(, , , ä) ʱ ⺻ 
void CSmartVideoCoreWrap::SetDefaultControl()
{
	m_pfSetDefaultControl();
}