// SmartVideoEncParamDlg.cpp :  Դϴ.
//

#include "stdafx.h"
#include "SmartVideoEVC.h"
#include "SmartVideoEncParamDlg.h"

////////////////////////////////////////////////////////////////////////////////////////
//    ĶͰ   ȭ  
////////////////////////////////////////////////////////////////////////////////////////

// CSmartVideoEncParamDlg ȭ Դϴ.

IMPLEMENT_DYNAMIC(CSmartVideoEncParamDlg, CDialog)

CSmartVideoEncParamDlg::CSmartVideoEncParamDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSmartVideoEncParamDlg::IDD, pParent)
{

}

CSmartVideoEncParamDlg::~CSmartVideoEncParamDlg()
{
}

void CSmartVideoEncParamDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TXTFR, m_TxtFR);
	DDX_Control(pDX, IDC_TXTBR, m_TxtBR);
	DDX_Control(pDX, IDC_TXTGOP, m_TxtGOP);
	DDX_Control(pDX, IDC_TXTIQP, m_TxtIQP);
	DDX_Control(pDX, IDC_TXTQPMAX, m_TxtQPMax);
	DDX_Control(pDX, IDC_TXTGA2, m_TxtGa);
}


BEGIN_MESSAGE_MAP(CSmartVideoEncParamDlg, CDialog)
	ON_BN_CLICKED(IDCANCEL, &CSmartVideoEncParamDlg::OnBnClickedCancel)
	ON_BN_CLICKED(IDOK, &CSmartVideoEncParamDlg::OnBnClickedOk)
	ON_EN_SETFOCUS(IDC_TXTFR, &CSmartVideoEncParamDlg::OnEnSetfocusTxtfr)
	ON_EN_KILLFOCUS(IDC_TXTFR, &CSmartVideoEncParamDlg::OnEnKillfocusTxtfr)
	ON_EN_SETFOCUS(IDC_TXTBR, &CSmartVideoEncParamDlg::OnEnSetfocusTxtbr)
	ON_EN_KILLFOCUS(IDC_TXTBR, &CSmartVideoEncParamDlg::OnEnKillfocusTxtbr)
	ON_EN_SETFOCUS(IDC_TXTGOP, &CSmartVideoEncParamDlg::OnEnSetfocusTxtgop)
	ON_EN_KILLFOCUS(IDC_TXTGOP, &CSmartVideoEncParamDlg::OnEnKillfocusTxtgop)
	ON_EN_SETFOCUS(IDC_TXTIQP, &CSmartVideoEncParamDlg::OnEnSetfocusTxtiqp)
	ON_EN_KILLFOCUS(IDC_TXTIQP, &CSmartVideoEncParamDlg::OnEnKillfocusTxtiqp)
	ON_EN_SETFOCUS(IDC_TXTQPMAX, &CSmartVideoEncParamDlg::OnEnSetfocusTxtqpmax)
	ON_EN_KILLFOCUS(IDC_TXTQPMAX, &CSmartVideoEncParamDlg::OnEnKillfocusTxtqpmax)
	ON_EN_SETFOCUS(IDC_TXTGA2, &CSmartVideoEncParamDlg::OnEnSetfocusTxtga2)
	ON_EN_KILLFOCUS(IDC_TXTGA2, &CSmartVideoEncParamDlg::OnEnKillfocusTxtga2)
END_MESSAGE_MAP()


// CSmartVideoEncParamDlg ޽ óԴϴ.

void CSmartVideoEncParamDlg::OnBnClickedCancel()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	OnCancel();
}

// ڿ Ҽ   ȯ chart -> double
// Windows Xp, 98, Vista, 7  ִ API Windows CE   
double wtof( const TCHAR *string )
{
	double dRet = 0;
	int  d, r, n;

	n = wcslen(string);
	r = -1;

	for (int i = 0; i < n; i++) 
	{
		if (string[i] == _T('.') ) 
		{ 
			r = i;
			continue;
		}

		if (!iswdigit(string[i]))
		{
			return 0;
		}

		d = string[i] - _T('0');
		dRet += d;
		dRet *= 10;
	}

	if( r == -1 )
	{
		r = n - 1;
	}

	dRet /= pow(10, n-r);

	return dRet;
}

//   Ķ 
void CSmartVideoEncParamDlg::OnBnClickedOk()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	CString strTemp;

	m_TxtFR.GetWindowTextW(strTemp);
	m_SetEncParas.iFrameRate = _wtoi(strTemp);

	m_TxtBR.GetWindowTextW(strTemp);
	m_SetEncParas.iBitRate = _wtoi(strTemp);
	
	m_TxtGOP.GetWindowTextW(strTemp);
	m_SetEncParas.iGOP = _wtoi(strTemp);
	
	m_TxtIQP.GetWindowTextW(strTemp);
	m_SetEncParas.iIQP = _wtoi(strTemp);
	
	m_TxtQPMax.GetWindowTextW(strTemp);
	m_SetEncParas.iQPMax = _wtoi(strTemp);
	
	m_TxtGa.GetWindowTextW(strTemp);
	m_SetEncParas.fGamma = wtof(strTemp);
	
	OnOK();
}

//     Ķ͸ ȭ ǥ
BOOL CSmartVideoEncParamDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ⿡ ߰ ʱȭ ۾ ߰մϴ.
	CString strTemp;

	strTemp.Format(L"%d", m_SetEncParas.iFrameRate);
	m_TxtFR.SetWindowTextW(strTemp);

	strTemp.Format(L"%d", m_SetEncParas.iBitRate);
	m_TxtBR.SetWindowTextW(strTemp);

	strTemp.Format(L"%d", m_SetEncParas.iGOP);
	m_TxtGOP.SetWindowTextW(strTemp);

	strTemp.Format(L"%d", m_SetEncParas.iIQP);
	m_TxtIQP.SetWindowTextW(strTemp);

	strTemp.Format(L"%d", m_SetEncParas.iQPMax);
	m_TxtQPMax.SetWindowTextW(strTemp);

	strTemp.Format(L"%f", m_SetEncParas.fGamma);
	m_TxtGa.SetWindowTextW(strTemp);

	return TRUE;  // return TRUE unless you set the focus to a control
	// : OCX Ӽ  FALSE ȯؾ մϴ.
}

// FrameRate  ؽƮ ý  Ű  ó
void CSmartVideoEncParamDlg::OnEnSetfocusTxtfr()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	SipShowIM(SIPF_ON);
}
// FrameRate  ؽƮ Focus   Ű带  ó
void CSmartVideoEncParamDlg::OnEnKillfocusTxtfr()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	SipShowIM(SIPF_OFF);
}

// BitRate  ؽƮ ý  Ű  ó
void CSmartVideoEncParamDlg::OnEnSetfocusTxtbr()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	SipShowIM(SIPF_ON);
}
// BitRate  ؽƮ Focus   Ű带  ó
void CSmartVideoEncParamDlg::OnEnKillfocusTxtbr()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	SipShowIM(SIPF_OFF);
}

// GOP  ؽƮ ý  Ű  ó
void CSmartVideoEncParamDlg::OnEnSetfocusTxtgop()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	SipShowIM(SIPF_ON);
}
// GOP  ؽƮ Focus   Ű带  ó
void CSmartVideoEncParamDlg::OnEnKillfocusTxtgop()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	SipShowIM(SIPF_OFF);
}

// IQP  ؽƮ ý  Ű  ó
void CSmartVideoEncParamDlg::OnEnSetfocusTxtiqp()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	SipShowIM(SIPF_ON);
}
// IQP  ؽƮ Focus   Ű带  ó
void CSmartVideoEncParamDlg::OnEnKillfocusTxtiqp()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	SipShowIM(SIPF_OFF);
}

// QPMax  ؽƮ ý  Ű  ó
void CSmartVideoEncParamDlg::OnEnSetfocusTxtqpmax()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	SipShowIM(SIPF_ON);
}
// QPMax  ؽƮ Focus   Ű带  ó
void CSmartVideoEncParamDlg::OnEnKillfocusTxtqpmax()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	SipShowIM(SIPF_OFF);
}

// Gamma  ؽƮ ý  Ű  ó
void CSmartVideoEncParamDlg::OnEnSetfocusTxtga2()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	SipShowIM(SIPF_ON);
}
// Gamma  ؽƮ Focus   Ű带  ó
void CSmartVideoEncParamDlg::OnEnKillfocusTxtga2()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	SipShowIM(SIPF_OFF);
}
