#pragma once

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Class SmartADC  C++(EVC++, Visual Studio 2005, 2008 ϵ Wrapping ClassԴϴ.
//  Class ϱ ؼ SmartADCWrap.h SmartADCWrap.cpp  Ʈ Ͽ Ͻñ ٶϴ.
//  
// ڼ  SmartX ޴  Ͻñ ٶϴ.
//
// www.hnsts.co.kr
// SmartX copyright(c)2002 All rights reserved by HNS Corp.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef void (*SetADCPrescaleEx)(unsigned long lPrescale);
typedef void (*SetFilteringEx)(bool bEnable);
typedef unsigned int (*GetADCDataEx)(int iCh);
typedef unsigned int (*GetDetailFilteringADCDataEx)(int iCh , int iRawdataCnt, int iAvailableCnt);

class CSmartADCWrap
{
private:
	HINSTANCE		m_hInst;

	SetADCPrescaleEx				m_pfSetADCPrescale;
	SetFilteringEx					m_pfSetFiltering;
	GetADCDataEx					m_pfGetADCData;
	GetDetailFilteringADCDataEx		m_pfGetDetailFilteringADCData;

public:
	CSmartADCWrap(void);
	~CSmartADCWrap(void);

	void SetADCPrescale(unsigned long lPrescale);
	void SetFiltering (bool bEnable);
	unsigned int GetADCData(int iCh);
	unsigned int GetDetailFilteringADCData(int iCh , int iRawdataCnt, int iAvailableCnt);

protected:
HICON m_hIcon;

};