///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Class SmartBattery  C++(EVC++) Visual Studio 2005, 2008 ϵ Wrapping ClassԴϴ.
//  Class ϱ ؼ SmartBatteryWrap.h SmartBatteryWrap.cpp  Ʈ Ͽ Ͻñ ٶϴ.
//  
// ڼ  SmartX-Programming Guide  Ͻñ ٶϴ.
//
// www.hnsts.co.kr
// SmartX copyright(c)2008 All rights reserved by HNS Corp.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "SmartBatteryWrap.h"

CSmartBatteryWrap::CSmartBatteryWrap(void)
{
	m_hInst = LoadLibrary(L"IEC667HWCON.dll");  // IEC667 ΰ

    if(m_hInst == NULL)
	{
        return;
	}

	// ̽ ȹ  (̽ νϽ óѴ.)
	m_pfSetBatteryVoltageLimit = (SetBatteryVoltageLimitEx)GetProcAddress(m_hInst, _T("SetBatteryVoltageLimit"));
	m_pfSetExtDCPowerInOffsetVoltage = (SetExtDCPowerInOffsetVoltageEx)GetProcAddress(m_hInst, _T("SetExtDCPowerInOffsetVoltage"));
	m_pfIsExtDCPowerIN = (IsExtDCPowerINEx)GetProcAddress(m_hInst, _T("IsExtDCPowerIN"));
	m_pfPowerOFF = (PowerOFFEx)GetProcAddress(m_hInst, _T("PowerOFF"));
	m_pfGetBatteryVoltage = (GetBatteryVoltageEx)GetProcAddress(m_hInst, _T("GetBatteryVoltage"));
	m_pfGetBatteryPercent = (GetBatteryPercentEx)GetProcAddress(m_hInst, _T("GetBatteryPercent"));
}

CSmartBatteryWrap::~CSmartBatteryWrap(void)
{
	FreeLibrary(m_hInst);
}

// а ּ  
//  : fMaxVoltage, fMinVoltage[(Volt)]
void CSmartBatteryWrap::SetBatteryVoltageLimit(double fMaxVoltage, double fMinVoltage)
{
	m_pfSetBatteryVoltageLimit(fMaxVoltage, fMinVoltage);
}

// ܺ   ߻Ǵ OffSet   
//  : fOffsetVoltage[(Volt)]
void CSmartBatteryWrap::SetExtDCPowerInOffsetVoltage(double fOffsetVoltage)
{
	m_pfSetExtDCPowerInOffsetVoltage(fOffsetVoltage);
}

//  ܺ DC    Ȯ
// ϰ : true -> ܺ  , false ->  Battery 
bool CSmartBatteryWrap::IsExtDCPowerIN()
{
	return m_pfIsExtDCPowerIN();
}

//  OFF մϴ.
// Լ ȣ 2  ܵ˴ϴ.
void CSmartBatteryWrap::PowerOFF()
{
	m_pfPowerOFF();
}

//  Battery а Ȯ
// ϰ : [Volt]
double CSmartBatteryWrap::GetBatteryVoltage()
{
	return m_pfGetBatteryVoltage();
}

//  Battery  뷮  Ȯ 
// ܺ    ̸ ̷   ¸ Ȯ
// ϰ :  %
int CSmartBatteryWrap::GetBatteryPercent()
{
	return m_pfGetBatteryPercent();
}