// SmartDACEVCDlg.cpp :  
//

#include "stdafx.h"
#include "SmartDACEVC.h"
#include "SmartDACEVCDlg.h"
#include "CTimePerformance.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CSmartDACEVCDlg ȭ 

CSmartDACEVCDlg::CSmartDACEVCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSmartDACEVCDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSmartDACEVCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TXTCH1, m_TxtCh1);
	DDX_Control(pDX, IDC_TXTCH2, m_TxtCh2);
}

BEGIN_MESSAGE_MAP(CSmartDACEVCDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON2, &CSmartDACEVCDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CSmartDACEVCDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_EXIT, &CSmartDACEVCDlg::OnBnClickedExit)
END_MESSAGE_MAP()


// CSmartDACEVCDlg ޽ ó

BOOL CSmartDACEVCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//  ȭ   մϴ.  α׷  â ȭ ڰ ƴ 쿡
	//  ӿũ  ۾ ڵ մϴ.
	SetIcon(m_hIcon, TRUE);			// ū  մϴ.
	SetIcon(m_hIcon, FALSE);		//   մϴ.	

	//DAC1ä ʱⰪ 2048 ʱȭ
	m_TxtCh1.SetWindowTextW(L"2048");
	//DAC2ä ʱⰪ 4095 ʱȭ
	m_TxtCh2.SetWindowTextW(L"4095");

	// DLL   ε Ǿ Ȯ ƾ
	if(m_SmartDAC.CheckDLL() == false)
	{
		AfxMessageBox(L"DLL  ϼ. α׷ ");

		CDialog::OnCancel();

		return false;
	}

	// DAC ʱȭ 
	m_SmartDAC.DAC_Initial();

	
	return TRUE;  // Ŀ Ʈѿ   TRUE ȯմϴ.
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CSmartDACEVCDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_SMARTDACEVC_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_SMARTDACEVC_DIALOG));
	}
}
#endif

// DAC 1ä   մϴ.
void CSmartDACEVCDlg::OnBnClickedButton2()
{
	int iData;
	CString strTxt;

	CTimePerformance cTime;
	
	m_TxtCh1.GetWindowText(strTxt);

	iData = _wtoi(strTxt);


	cTime.Begin();
	for(int i = 0; i < 10000;i++)
	{
	    // Analog ȯ 
	    m_SmartDAC.SetOutData1(iData);
    }
//Sleep(1000);
	cTime.End();

	CString str;
	str.Format(L"elapsed time : %f ms", cTime.GetElapsedTime() /10);
	AfxMessageBox(str);
}

// DAC 2ä   մϴ.
void CSmartDACEVCDlg::OnBnClickedButton3()
{
	int iData;
	CString strTxt;

	CTimePerformance cTime;
	//  ڵ
	// iData = 4000;

	m_TxtCh2.GetWindowText(strTxt);

	iData = _wtoi(strTxt);

	cTime.Begin();
	for(int i = 0; i < 10000;i++)
	{
	    // Analog ȯ 
	    m_SmartDAC.SetOutData2(iData);
    }
//Sleep(1000);
	cTime.End();

	CString str;
	str.Format(L"elapsed time : %f ms", cTime.GetElapsedTime() /10);
	AfxMessageBox(str);

	
}

void CSmartDACEVCDlg::OnBnClickedExit()
{
	CSmartDACEVCDlg::OnOK();
}
