// SmartI2CDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SmartI2C.h"
#include "SmartI2CDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CSmartI2CDlg dialog

CSmartI2CDlg::CSmartI2CDlg(CWnd* pParent /*=NULL*/)
: CDialog(CSmartI2CDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSmartI2CDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSmartI2CDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSmartI2CDlg)
	DDX_Control(pDX, IDC_SLVADDR, m_SlvAddr);
	DDX_Control(pDX, IDC_MEMDATA, m_MemData);
	DDX_Control(pDX, IDC_MEMADDR, m_MemAddr);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSmartI2CDlg, CDialog)
	//{{AFX_MSG_MAP(CSmartI2CDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnEEPROMWRITE)
	ON_BN_CLICKED(IDC_BUTTON2, OnEEPROMREAD)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSmartI2CDlg message handlers

BOOL CSmartI2CDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	//  Bug   ̽ νϽ  óѴ.
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CSmartI2CDlg::OnEEPROMWRITE() 
{
	int					iSlaveAddress;
	CString				strSlaveAddress;
	int					iMemAddress;
	CString				strMemAddress;
	int					iMemData;
	CString				strMemData;


	m_SlvAddr.GetWindowText(strSlaveAddress);
	m_MemAddr.GetWindowText(strMemAddress);
	m_MemData.GetWindowText(strMemData);


	iSlaveAddress = _wtoi(strSlaveAddress);
	iMemAddress = _wtoi(strMemAddress);
	iMemData = _wtoi(strMemData);

	if(m_hInst == NULL)
	{
		return;
	}

	//AT24C16 DataSheet ϼ.
	m_SmartI2C.StartSignal();
	m_SmartI2C.WriteByte(iSlaveAddress);
	m_SmartI2C.WriteByte(iMemAddress);
	m_SmartI2C.WriteByte(iMemData);
	m_SmartI2C.StopSignal();
	Sleep(100);

}

void CSmartI2CDlg::OnEEPROMREAD() 
{
	int					iSlaveAddress;
	CString				strSlaveAddress;
	int					iMemAddress;
	CString				strMemAddress;
	int					iMemData;
	CString				strMemData;


	m_SlvAddr.GetWindowText(strSlaveAddress);
	m_MemAddr.GetWindowText(strMemAddress);


	iSlaveAddress = _wtoi(strSlaveAddress);
	iMemAddress = _wtoi(strMemAddress);

	if(m_hInst == NULL)
	{
		return;
	}

	int iSlaveTemp;


	//AT24C16 DataSheet ϼ.
	//   ȣ ߻ϴ Լ
	m_SmartI2C.StartSignal();

	// IIC(I2C)  Ʈ ͸ ۽
	m_SmartI2C.WriteByte(iSlaveAddress);

	// IIC(I2C)  Ʈ ͸ ۽
	m_SmartI2C.WriteByte(iMemAddress);

	//   ȣ ߻ϴ Լ
	m_SmartI2C.StartSignal();

	// IIC(I2C)  Ʈ ͸ ۽
	m_SmartI2C.WriteByte(iSlaveAddress | 1);

	// IIC(I2C)  ͸ . 
	iMemData = m_SmartI2C.ReadByte(NOACK);

	//   ȣ ߻ϴ Լ
	m_SmartI2C.StopSignal();

	strMemData.Format(L"%d", iMemData);
	m_MemData.SetWindowText(strMemData);
}

void CSmartI2CDlg::OnClose() 
{
	FreeLibrary(m_hInst);

	CDialog::OnClose();
}
