///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Class SmartI2C  C++(EVC++, Visual Studio 2005, 2008) ϵ Wrapping ClassԴϴ.
//  Class ϱ ؼ SmartI2CWrap.h SmartI2CWrap.cpp  Ʈ Ͽ Ͻñ ٶϴ.
//    Ե "DLL\IEC667HWCON.dll" Ǵ ϰ   Ͽ Ͻñ ٶϴ.
//  
// ڼ  SmartX ޴  Ͻñ ٶϴ.
//
// SmartX copyright(c)2002 All rights reserved by HNS Corp.   www.hnsts.co.kr
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SmartI2CWrap.h"

CSmartI2CWrap::CSmartI2CWrap(void)
{
	m_hInst = LoadLibrary(L"IEC667HWCON.dll");

	if(m_hInst == NULL)
	{
		return;
	}

	m_pfInit = (InitEx)GetProcAddress(m_hInst, _T("Init"));
	m_pfSetACKWaitTimeOut = (SetACKWaitTimeOutEx)GetProcAddress(m_hInst, _T("SetACKWaitTimeOut"));
	m_pfSetSpeed = (SetSpeedEx)GetProcAddress(m_hInst, _T("SetSpeed"));
	m_pfStartSignal = (StartSignalEx)GetProcAddress(m_hInst, _T("StartSignal"));
	m_pfStopSignal = (StopSignalEx)GetProcAddress(m_hInst, _T("StopSignal"));
	m_pfReadByte = (ReadByteEx)GetProcAddress(m_hInst, _T("ReadByte"));
	m_pfWriteByte = (WriteByteEx)GetProcAddress(m_hInst, _T("WriteByte"));
}

CSmartI2CWrap::~CSmartI2CWrap(void)
{
	FreeLibrary(m_hInst);
}

// IIC(I2C)  ϱ ؼ ӵ  Ʈ IIC(I2C)  ʱȭ 
void CSmartI2CWrap::Init()
{
	m_pfInit();
}

// IIC(I2C)  Read_Byte(ACK)޼ · ȣ  ACK ŵɶ ٸ
// ̰   ̽ ACK  ʰԵǸ   ٸ Ǿ α׷   ʰ Ǵ  ߻
// ̷  ϱ   ð ACK   ACK SKIP  ֵ ACK Wait TimeOutϴ 
void CSmartI2CWrap::SetACKWaitTimeOut(long lInterval)
{
	m_pfSetACKWaitTimeOut(lInterval);
}

// IIC(I2C) ӵ õ   Դϴ. ⺻  0 .
//   ϳ ȣ 1/1000  Դϴ. 
void CSmartI2CWrap::SetSpeed(long lSpeed)
{
	m_pfSetSpeed(lSpeed);
}

// IIC(I2C)  ִ ʹ(IEC Series)  / Ҷ   ߻ϰ  /   ߻. 
//   ߻Ų ʹ  ߻Ҷ  ϰ ǰ ̶ ٸ ʹ Ұ.
// IIC(I2C)       ۽Ÿ尡 ֽϴ. 
//   ȣ ߻ϴ Լ
bool CSmartI2CWrap::StartSignal()
{
	return m_pfStartSignal();
}

//   ȣ ߻ϴ Լ
bool CSmartI2CWrap::StopSignal()
{
	return m_pfStopSignal();
}

// IIC(I2C)  ͸ . ڷδ ACK NOACK̸ ACK ΰ ACK ŵɶ ٸ. 
//     SetACKWaitTimeOut() Լ   Wait TimeOut ó
unsigned char CSmartI2CWrap::ReadByte(EACK eACK)
{
	return m_pfReadByte(eACK);
}

// IIC(I2C)  Ʈ ͸ ۽
// ù° ڴ ۽ Ʈ ,  ڴ ACK NOACK   ߻ 
bool CSmartI2CWrap::WriteByte(unsigned char uchData)
{
	return m_pfWriteByte(uchData);
}