///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Class SmartLock  C++(EVC++, Visual Studio 2005, 2008) ϵ Wrapping ClassԴϴ.
//  Class ϱ ؼ SmartLockWrap.h SmartLockWrap.cpp  Ʈ Ͽ Ͻñ ٶϴ.
//    Ե "DLL\SmartLockCore.dll" Ǵ ϰ   Ͽ Ͻñ ٶϴ.
//  
// ڼ  SmartX Framework α׷ ̵带  Ͻñ ٶϴ.
//
// SmartX copyright(c)2008 All rights reserved by HNS Corp.   www.hnsts.co.kr
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "SmartLockWrap.h"

CSmartLockWrap::CSmartLockWrap(void)
{
	m_hInst = LoadLibrary(L"SmartLockCore.dll");

    if(m_hInst == NULL)
	{
		AfxMessageBox(L"SmartLockCore.DLL File Not Found...!!!");
		m_hInst = NULL;
        return;
	}

	// ̽ ȹ  (̽ νϽ óѴ.)
    m_pfSetTitle = (SetTitleEx)GetProcAddress(m_hInst, _T("SetTitle"));
	m_pfSetReferenceSNKeys = (SetReferenceSNKeysEx)GetProcAddress(m_hInst, _T("SetReferenceSNKeys"));
	m_pfSetAutoRegistrationFilePathName = (SetAutoRegistrationFilePathNameEx)GetProcAddress(m_hInst, _T("SetAutoRegistrationFilePathName"));
	m_pfRegistrationCheck = (RegistrationCheckEx)GetProcAddress(m_hInst, _T("RegistrationCheck"));
	m_pfAutoRegistrationApply = (AutoRegistrationApplyEx)GetProcAddress(m_hInst, _T("AutoRegistrationApply"));
	m_pfRegistrationFormShow = (RegistrationFormShowEx)GetProcAddress(m_hInst, _T("RegistrationFormShow"));
	
}

CSmartLockWrap::~CSmartLockWrap(void)
{
	if(m_hInst != NULL)
	{
		FreeLibrary(m_hInst);
	}
}

// α׷  Ͽ ǰŰ Է ȭ鿡  ޽  
// [  ]
// LPTSTR strTitle :  ޽ ڿ Է
void CSmartLockWrap::SetTitle(LPTSTR strTitle)
{
	m_pfSetTitle(strTitle);
}

// α׷ Ͻ  Ǵ ǰŰ   Ѵ. Լ  Ű ǰϽ ԷµǴ ǰŰ  
// Ͽ  Ű  Ұ α׷  óѴ.
// Ű   Է Ҽ  ϳ Ű ̴ 20ڸ  ȵȴ.
// ǰ Ű  ݷ ϸ  ڿ ĺ 빮 ׸ '-' ȣ   մϴ.
// [  ]
// LPTSTR strRefSNKeys : ǰ Ű ڿ Է [Է¿] "123A-3KF;FSW1-342;33FA-778;7890-990;ABCD-EFG;"
void CSmartLockWrap::SetReferenceSNKeys(LPTSTR strRefSNKeys)
{
	m_pfSetReferenceSNKeys(strRefSNKeys);
}

// ڵ Ͻ ʿ ǰŰ ϸ θ մϴ. 
// [  ]
// LPTSTR strFilePathName : ǰŰ ԷµǾ ִ Text ιڿ
void CSmartLockWrap::SetAutoRegistrationFilePathName(LPTSTR strFilePathName)
{
	m_pfSetAutoRegistrationFilePathName(strFilePathName);
}

// α׷ ϵǾִ Ȯ
// ϰ : True -> ϵǾ , False -> ϵǾ  
bool CSmartLockWrap::RegistrationCheck()
{
	return m_pfRegistrationCheck();
}

// α׷ ڵ  óѴ.  Լ ȣǸ SetAutoRegistrationFilePathName()Լ  
//   о о帰  ǰ Ű մϴ.
// [ ϰ ]
// 0 :  Ϸ()
// 1 : ڵ  ʿ SN Key   ο  ()
// 2 : ߸ SN Key Է()
// 3 : SN Key  ()
int	CSmartLockWrap::AutoRegistrationApply()
{
	return m_pfAutoRegistrationApply();
}

// α׷ ϱ â(ǰŰ Էâ) մϴ.
// [ ϰ ]
// 0 :  Ϸ()
// 1 :  
int CSmartLockWrap::RegistrationFormShow()
{
	return m_pfRegistrationFormShow();
}