// SmartPWMEVCDlg.h : header file
//
#pragma once

#include "SmartPWMWrap.h"
#include "afxwin.h"

#if !defined(AFX_SMARTPWMEVCDLG_H__0746C2FC_12AA_4241_B609_A68DEE3AF2C5__INCLUDED_)
#define AFX_SMARTPWMEVCDLG_H__0746C2FC_12AA_4241_B609_A68DEE3AF2C5__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


/////////////////////////////////////////////////////////////////////////////
// CSmartPWMEVCDlg dialog
class CSmartPWMEVCDlg : public CDialog
{
private:
	CSmartPWMWrap		m_SmartPWM;

// Construction
public:
	CSmartPWMEVCDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CSmartPWMEVCDlg)
	enum { IDD = IDD_SMARTPWMEVC_DIALOG };
	CEdit	m_EditCay2;
	CEdit	m_EditPre;
	CEdit	m_EditDuty2;
	CEdit	m_EditDuty1;
	CEdit	m_EditDeadTime;
	CEdit	m_EditCay1;
	CButton	m_ChkPol2;
	CButton	m_ChkPol1;
	CButton	m_Chk28;
	CButton	m_Chk24;
	CButton	m_Chk22;
	CButton	m_Chk216;
	CButton	m_Chk18;
	CButton	m_Chk14;
	CButton	m_Chk12;
	CButton	m_Chk116;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSmartPWMEVCDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CSmartPWMEVCDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnCarryInc();
	afx_msg void OnCarryDec();
	afx_msg void OnDutyInc1();
	afx_msg void OnDutyDec1();
	afx_msg void OnPreScaleInc();
	afx_msg void OnPreScaleDec();
	afx_msg void OnDeadTimeInc();
	afx_msg void OnDeadTimeDec();
	afx_msg void OnCarryInc2();
	afx_msg void OnCarryDec2();
	afx_msg void OnDutyInc2();
	afx_msg void OnDutyDec2();
	afx_msg void OnChk12();
	afx_msg void OnChk14();
	afx_msg void OnChk18();
	afx_msg void OnChk116();
	afx_msg void OnChk22();
	afx_msg void OnChk24();
	afx_msg void OnChk28();
	afx_msg void OnChk216();
	afx_msg void OnChkpol1();
	afx_msg void OnChkpol2();
	afx_msg void OnPWM1Start();
	afx_msg void OnPWM1Stop();
	afx_msg void OnPWM2Start();
	afx_msg void OnPWM2Stop();
	afx_msg void OnRestore();
	afx_msg void OnClose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	unsigned int		m_iCarry1;
	unsigned int		m_Duty1;
	unsigned int		m_iCarry2;
	unsigned int		m_Duty2;
	unsigned char		m_ucDeadTime;
	unsigned char		m_ucPreSet;

	bool				m_bPWMStart;

	HINSTANCE			m_hInst;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft eMbedded Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SMARTPWMEVCDLG_H__0746C2FC_12AA_4241_B609_A68DEE3AF2C5__INCLUDED_)
