///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Class SmartPWM  C++(EVC++, Visual Studio 2005, 2008) ϵ Wrapping ClassԴϴ.
//  Class ϱ ؼ SmartPWMWrap.h SmartPWMWrap.cpp  Ʈ Ͽ Ͻñ ٶϴ.
//    Ե "DLL\IEC667HWCON.dll" Ǵ ϰ   Ͽ Ͻñ ٶϴ.
//  
// ڼ  SmartX ޴  Ͻñ ٶϴ.
//
// SmartX copyright(c)2002 All rights reserved by HNS Corp.   www.hnsts.co.kr
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SmartPWMWrap.h"

CSmartPWMWrap::CSmartPWMWrap(void)
{
	m_hInst = LoadLibrary(L"IEC667HWCON.dll");

	if(m_hInst == NULL)
	{
		return;
	}
	
	m_pfSetPWMPrescaler = (SetPWMPrescalerEx)GetProcAddress(m_hInst, _T("SetPWMPrescaler"));
	
	m_pfSetPWMClkDivider1 = (SetPWMClkDivider1Ex)GetProcAddress(m_hInst, _T("SetPWMClkDivider1"));
	m_pfSetPWMClkDivider2 = (SetPWMClkDivider2Ex)GetProcAddress(m_hInst, _T("SetPWMClkDivider2"));
	
	m_pfSetPWMCounter1 = (SetPWMCounter1Ex)GetProcAddress(m_hInst, _T("SetPWMCounter1"));
	m_pfSetPWMCounter2 = (SetPWMCounter2Ex)GetProcAddress(m_hInst, _T("SetPWMCounter2"));

	m_pfSetPWMDeadTime = (SetPWMDeadTimeEx)GetProcAddress(m_hInst, _T("SetPWMDeadTime"));

	m_pfSetPWMPolarity1 = (SetPWMPolarity1Ex)GetProcAddress(m_hInst, _T("SetPWMPolarity1"));
	m_pfSetPWMPolarity2 = (SetPWMPolarity2Ex)GetProcAddress(m_hInst, _T("SetPWMPolarity2"));

	m_pfSetPWMCarryFreq1 = (SetPWMCarryFreq1Ex)GetProcAddress(m_hInst, _T("SetPWMCarryFreq1"));
	m_pfSetPWMCarryFreq2 = (SetPWMCarryFreq2Ex)GetProcAddress(m_hInst, _T("SetPWMCarryFreq2"));

	m_pfSetPWMDutyRate1 = (SetPWMDutyRate1Ex)GetProcAddress(m_hInst, _T("SetPWMDutyRate1"));
	m_pfSetPWMDutyRate2 = (SetPWMDutyRate2Ex)GetProcAddress(m_hInst, _T("SetPWMDutyRate2"));

	m_pfStart_PWM1 = (Start_PWM1Ex)GetProcAddress(m_hInst, _T("Start_PWM1"));
	m_pfStart_PWM2 = (Start_PWM2Ex)GetProcAddress(m_hInst, _T("Start_PWM2"));

	m_pfStop_PWM1 = (Stop_PWM1Ex)GetProcAddress(m_hInst, _T("Stop_PWM1"));
	m_pfStop_PWM2 = (Stop_PWM2Ex)GetProcAddress(m_hInst, _T("Stop_PWM2"));

	m_pfPWMRestore = (PWMRestoreEx)GetProcAddress(m_hInst, _T("PWMRestore"));
}

CSmartPWMWrap::~CSmartPWMWrap(void)
{
	FreeLibrary(m_hInst);
}

// ucPrescaler  0~255 Ҽ Prescaler  PWM ĳ ļ  
// PWM1  PWM2  Prescaler 
// []unsigned char ucPrescaler : Prescaler 
void CSmartPWMWrap::SetPWMPrescaler(unsigned char ucPrescaler)
{
	m_pfSetPWMPrescaler(ucPrescaler);
}

// Prescaler  PWM Ŭ ޵Ǹ Ŭ  ٽ Ŭ ̴  ֵ. SetPWMClkDivider  ְ 
void CSmartPWMWrap::SetPWMClkDivider1(unsigned char ucClkDivider1)
{
	m_pfSetPWMClkDivider1(ucClkDivider1);
}

// Prescaler  PWM Ŭ ޵Ǹ Ŭ  ٽ Ŭ ̴  ֵ. SetPWMClkDivider  ְ 
void CSmartPWMWrap::SetPWMClkDivider2(unsigned char ucClkDivider2)
{
	m_pfSetPWMClkDivider2(ucClkDivider2);
}

// SetPWMCounter 16Bit̸ PWM ĳ ļ ϰ 
void CSmartPWMWrap::SetPWMCounter1(unsigned int uiPwmCounter1)
{
	m_pfSetPWMCounter1(uiPwmCounter1);
}

// SetPWMCounter 16Bit̸ PWM ĳ ļ ϰ 
void CSmartPWMWrap::SetPWMCounter2(unsigned int uiPwmCounter2)
{
	m_pfSetPWMCounter2(uiPwmCounter2);
}

//  Ÿ  ־   PWM 밡. 
// ŸӰ 0 ū PWM1 PWM2  Ǿ . PWM1 High Side PWM2 Low Side Ǿ .
void CSmartPWMWrap::SetPWMDeadTime(unsigned char ucDeadTime)
{
	m_pfSetPWMDeadTime(ucDeadTime);
}

// PWM1   / .  Ͽ PWM .
void CSmartPWMWrap::SetPWMPolarity1(bool bPolarity1)
{
	m_pfSetPWMPolarity1(bPolarity1);
}

// PWM2   / .  Ͽ PWM .
void CSmartPWMWrap::SetPWMPolarity2(bool bPolarity2)
{
	m_pfSetPWMPolarity2(bPolarity2);
}

// PWM ĳ ļ  ڵ  .
// []ucPreScaler:Ϸ , ucDivider:Ŭ̴, uiPWMCounter:PWMī
void CSmartPWMWrap::SetPWMCarryFreq1(unsigned char ucPreScaler, unsigned char ucDivider, unsigned int uiPWMCounter)
{
	m_pfSetPWMCarryFreq1(ucPreScaler, ucDivider, uiPWMCounter);
}

// []ucPreScaler:Ϸ , ucDivider:Ŭ̴, uiPWMCounter:PWMī
void CSmartPWMWrap::SetPWMCarryFreq2(unsigned char ucPreScaler, unsigned char ucDivider, unsigned int uiPWMCounter)
{
	m_pfSetPWMCarryFreq2(ucPreScaler, ucDivider, uiPWMCounter);
}

// PWM1  Ƽ  . 0 ~ 100.00 (Ǽ  : double type)
void CSmartPWMWrap::SetPWMDutyRate1(double dButyRAte1)
{
	m_pfSetPWMDutyRate1(dButyRAte1);
}

// PWM2  Ƽ  . 0 ~ 100.00 (Ǽ  : double type)
void CSmartPWMWrap::SetPWMDutyRate2(double dButyRAte2)
{
	m_pfSetPWMDutyRate2(dButyRAte2);
}

// PWM1  Ķ  Ϸ PWM  ϵ ϴ Լ
void CSmartPWMWrap::Start_PWM1()
{
	m_pfStart_PWM1();
}

// PWM2  Ķ  Ϸ PWM  ϵ ϴ Լ
void CSmartPWMWrap::Start_PWM2()
{
	m_pfStart_PWM2();
}

// PWM1  
void CSmartPWMWrap::Stop_PWM1()
{
	m_pfStop_PWM1();
}

// PWM2  
void CSmartPWMWrap::Stop_PWM2()
{
	m_pfStop_PWM2();
}

// α׷   PWM  ͸ ʱ· 
// ReleasePWM()ȣ PWM   ҽ  ȯϿ α׷  . 
void CSmartPWMWrap::PWMRestore()
{
	m_pfPWMRestore();
}