///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Class SmartPlayer  C++(EVC++, Visual Studio 2005, 2008) ϵ Wrapping ClassԴϴ.
//  Class ϱ ؼ SmartPlayWrap.h SmartPlayWrap.cpp  Ʈ Ͽ Ͻñ ٶϴ.
//    Ե "DLL\SmartPlayCore.dll" Ǵ ϰ   Ͽ Ͻñ ٶϴ.
//  
// ڼ  SmartX ޴  Ͻñ ٶϴ.
//
// SmartX copyright(c)2008 All rights reserved by HNS Corp.   www.hnsts.co.kr
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "SmartPlayWrap.h"

CSmartPlayWrap::CSmartPlayWrap(void)
{
	m_hInst = LoadLibrary(L"SmartPlayCore.dll");

	if(m_hInst == NULL)
	{
		AfxMessageBox(L"SmartPlayCore.DLL File Not Found...!!!");
		m_hInst = NULL;
        return;
	}

	// ̽ ȹ  (̽ νϽ óѴ.)
 m_pfInitialization = (InitializationEx)GetProcAddress(m_hInst, _T("Initialization"));
	m_pfSetPreviewWindowHandle = (SetPreviewWindowHandleEx)GetProcAddress(m_hInst, _T("SetPreviewWindowHandle"));
	m_pfOpen = (OpenEx)GetProcAddress(m_hInst, _T("Open"));
	m_pfOpen1 = (OpenEx1)GetProcAddress(m_hInst, _T("Open1"));
	m_pfPlay = (PlayEx)GetProcAddress(m_hInst, _T("Play"));
	m_pfStop = (StopEx)GetProcAddress(m_hInst, _T("Stop"));
	m_pfPause = (PauseEx)GetProcAddress(m_hInst, _T("Pause"));
	m_pfIsComplete = (IsCompleteEx)GetProcAddress(m_hInst, _T("IsComplete"));
	m_pfGetCurrentPos = (GetCurrentPosEx)GetProcAddress(m_hInst, _T("GetCurrentPos"));
	m_pfGetMaxPos = (GetMaxPosEx)GetProcAddress(m_hInst, _T("GetMaxPos"));
	m_pfSetCurrentPos = (SetCurrentPosEx)GetProcAddress(m_hInst, _T("SetCurrentPos"));
	m_pfGetVolume = (GetVolumeEx)GetProcAddress(m_hInst, _T("GetVolume"));
	m_pfSetVolume = (SetVolumeEx)GetProcAddress(m_hInst, _T("SetVolume"));
	m_pfViewFullSize = (ViewFullSizeEx)GetProcAddress(m_hInst, _T("ViewFullSizeMode"));
}

CSmartPlayWrap::~CSmartPlayWrap(void)
{
	if(m_hInst != NULL)
	{
		FreeLibrary(m_hInst);
	}
}

// SmartPlayCore.dll  LoadǾ Ȯ
//   : true -> Load , false -> 
bool CSmartPlayWrap::IsLoadDll()
{
	if(m_hInst != NULL)
	{
		return true;
	}
	
	return false;
}

// SmartPlayer ϱ ʱȭ ó
void CSmartPlayWrap::Initialization(void)
{
	m_pfInitialization();
}

// Play View â  WindowǴ Ʈ ڵ  մϴ. 
//  : Play View â Handle 
void CSmartPlayWrap::SetPreviewWindowHandle(HWND hPreviewWindow)
{
	m_pfSetPreviewWindowHandle(hPreviewWindow);
}

//   Openϸ View ũ  ػ󵵿 ϰ 
//  :   ι ̸
// ϰ : true->Open , false->Open 
bool CSmartPlayWrap::Open(WCHAR* strFilePathName)
{
	return m_pfOpen(strFilePathName);
}

//   Openϸ View ũ⸦    .
//  :   ι ̸, Viewȭ ũ ũ
// ϰ : true->Open , false->Open 
bool CSmartPlayWrap::Open(WCHAR* strFilePathName, long lWidth, long lHeight)
{
	return m_pfOpen1(strFilePathName, lWidth, lHeight);
}

//   Ȯ
// ϰ : true->, false->
bool CSmartPlayWrap::IsComplete() 
{
    return m_pfIsComplete();
}

// Open   մϴ.
// ϰ : true->, false->
bool CSmartPlayWrap::Play(void)
{
	return m_pfPlay();
}

//    մϴ.
// ϰ : true->, false->
bool CSmartPlayWrap::Stop(void)
{
	if(IsLoadDll() == true)
	{
		return m_pfStop();
	}
}

//   Ͻ մϴ.
// ϰ : true->, false->
bool CSmartPlayWrap::Pause(void)
{
	return m_pfPause();
}

//    ġ  մϴ.
// ϰ :  ġ ʴ 
DWORD CSmartPlayWrap::GetCurrentPos()
{
	return m_pfGetCurrentPos();
}

//   ð  մϴ.
// ϰ : Open   ð ʴ 
DWORD CSmartPlayWrap::GetMaxPos()
{
	return m_pfGetMaxPos();
}

//    ġ  մϴ.
// ϰ : true->, false->
//  : ġ ʴ 
bool CSmartPlayWrap::SetCurrentPos(DWORD dwPos)
{
	return m_pfSetCurrentPos(dwPos);
}

//   ũ⸦  մϴ.
// ϰ :   ũ
long CSmartPlayWrap::GetVolume()
{
	return m_pfGetVolume();
}

//   ũ⸦  մϴ.
// ϰ : true->, false->
//  :   ũ 
bool CSmartPlayWrap::SetVolume(long lVol)
{
	return m_pfSetVolume(lVol);
}

//  ȭ ũ⸦ 带  մϴ.
// ϰ : true->, false->
//  : true->üȭ ũ, false-> ȭũ 
bool CSmartPlayWrap::ViewFullSize(bool bMode)
{
	return m_pfViewFullSize(bMode);
}