// SmartPrintEVCDlg.cpp :  
//

#include "stdafx.h"
#include "SmartPrintEVC.h"
#include "SmartPrintEVCDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CSmartPrintEVCDlg ȭ 

CSmartPrintEVCDlg::CSmartPrintEVCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSmartPrintEVCDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSmartPrintEVCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LABMSG, m_LabPrnStatus);
	DDX_Control(pDX, IDC_DPI300, m_rad300DPI);
	DDX_Control(pDX, IDC_DPI600, m_rad600DPI);

	DDX_Control(pDX, IDC_COLOR, m_radColor);
	DDX_Control(pDX, IDC_MONO, m_radMono);

	DDX_Control(pDX, IDC_VER, m_radVer);
	DDX_Control(pDX, IDC_HOR, m_radHor);
}

BEGIN_MESSAGE_MAP(CSmartPrintEVCDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CSmartPrintEVCDlg::OnBnClickedButton1)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON2, &CSmartPrintEVCDlg::OnBnClickedButton2)
END_MESSAGE_MAP()


// CSmartPrintEVCDlg ޽ ó

BOOL CSmartPrintEVCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//  ȭ   մϴ.  α׷  â ȭ ڰ ƴ 쿡
	//  ӿũ  ۾ ڵ մϴ.
	SetIcon(m_hIcon, TRUE);			// ū  մϴ.
	SetIcon(m_hIcon, FALSE);		//   մϴ.

	// TODO: ⿡ ߰ ʱȭ ۾ ߰մϴ.
	m_LabPrnStatus.SetWindowTextW(L"μ غ.!!!");
	

	// μ ɼ ư ʱ 
	m_rad300DPI.SetCheck(BST_CHECKED);
	m_radColor.SetCheck(BST_CHECKED);
	m_radVer.SetCheck(BST_CHECKED);

	return TRUE;  // Ŀ Ʈѿ   TRUE ȯմϴ.
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CSmartPrintEVCDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_SMARTPRINTEVC_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_SMARTPRINTEVC_DIALOG));
	}
}
#endif


void CSmartPrintEVCDlg::OnBnClickedButton1()
{
	// μ 
	int iSelColorMode;
	int iSelPaperDir;

	// Į ɼǼ
	if(m_radColor.GetCheck() == BST_CHECKED)
	{
		// Į 
		iSelColorMode = 1;
	}
	else
	{
		// 
		iSelColorMode = 0;
	}

	// μ    
	if(m_radVer.GetCheck() == BST_CHECKED)
	{
		//  
		iSelPaperDir = 1;	
	}
	else
	{
		//  
		iSelPaperDir = 0;	
	}

	// μ ػ ɼ 
	if(m_rad300DPI.GetCheck() == BST_CHECKED)
	{
		// 300DPI ػ 
		m_SmartPrint.PrintSetup(L"PCL Inkjet", 0, iSelColorMode, 0, iSelPaperDir, 1);
	}
	else
	{
		// 600DPI ػ 
		m_SmartPrint.PrintSetup(L"PCL Inkjet", 1, iSelColorMode, 0, iSelPaperDir, 1);
	}

	m_SmartPrint.SethInstance(AfxGetResourceHandle());

	// μ Ʈ 
	m_SmartPrint.SetFontCfg(L"ü", 70, RGB(255, 255, 255), true, false, false);

	//  Ӽ 
	m_SmartPrint.SetPenStyle(RGB(200,0,0), 5);
	m_SmartPrint.SetBrushStyle(RGB(255, 255, 255), true);
	//  ܰ   ۿ ׸
	m_SmartPrint.Rectangle(3, 3, 2390, 3300); 
	
	//   ۿ ׸
	m_SmartPrint.SetBrushStyle(RGB(12, 56, 100), false);
	m_SmartPrint.SetPenStyle(RGB(0,200,0), 2);
	m_SmartPrint.RoundRect(100, 120, 2220, 150, 40);
	m_SmartPrint.TextOut(123, 160, L"HNS SmartX / SmartPrint Example Printing [ www.hnsts.co.kr ]");

	//  ȭ ۿ ׸
	m_SmartPrint.DisplayToPrint(100, 350);
	// ׶̼ ۿ ׸
	m_SmartPrint.GradientFill(1010, 350, 400, 480, RGB(170, 0, 0), RGB(0, 0, 170), GRADIENT_FILL_RECT_H);
	// ҽ ̹  ۿ ׸
	m_SmartPrint.ImageDraw(IDB_BITMAP1, 1520, 350);

	//    ۿ ׸.
	m_SmartPrint.SetPenStyle(RGB(0, 150, 50), 3);
	m_SmartPrint.SetBrushStyle(RGB(255, 255, 255), true);
	m_SmartPrint.RoundRect(100, 950, 2220, 750, 40);
	m_SmartPrint.SetBrushStyle(RGB(0, 150, 50), false);
	m_SmartPrint.RoundRect(100, 950, 2220, 150, 40);
	m_SmartPrint.Rectangle(100, 1000, 2220, 100);
	m_SmartPrint.TextOut(140, 990, L"SmartPrint Draw shape Function Test...");

	//    ۿ ׸.
	m_SmartPrint.SetPenStyle(RGB(77, 150, 0), 5);
	m_SmartPrint.SetBrushStyle(RGB(175, 175, 0), false);
	m_SmartPrint.Circle(300, 1400, 170);
	m_SmartPrint.SetPenStyle(RGB(77, 0, 0), 50);
	m_SmartPrint.SetBrushStyle(RGB(255, 255, 255), true);
	m_SmartPrint.Circle(500, 1400, 270);
	//    ۿ ׸.
	m_SmartPrint.SetPenStyle(RGB(0, 77, 150), 5);
	m_SmartPrint.SetBrushStyle(RGB(75, 0, 0), false);
	m_SmartPrint.Ellipse(1200, 1400, 300, 100);
	m_SmartPrint.SetPenStyle(RGB(0, 0, 77), 50);
	m_SmartPrint.SetBrushStyle(RGB(255, 255, 255), true);
	m_SmartPrint.Ellipse(1200, 1400, 100, 300);

	//  ׸  ǥ    
	POINT points[10];
	int iSize, iXOffset, iYOffset;

	iXOffset = 1600;
	iYOffset = 1150;
	iSize = 10;
    points[0].x = (16 * iSize) + iXOffset;
    points[0].y = (28 * iSize) + iYOffset;
    points[1].x = (19 * iSize) + iXOffset;
    points[1].y = (17 * iSize) + iYOffset;
    points[2].x = (30 * iSize) + iXOffset;
    points[2].y = (17 * iSize) + iYOffset;
    points[3].x = (21 * iSize) + iXOffset;
    points[3].y = (11 * iSize) + iYOffset;
    points[4].x = (25 * iSize) + iXOffset;
    points[4].y = (1 * iSize) + iYOffset;
    points[5].x = (16 * iSize) + iXOffset;
    points[5].y = (7 * iSize) + iYOffset;
    points[6].x = (7 * iSize) + iXOffset;
    points[6].y = (1 * iSize) + iYOffset;
    points[7].x = (11 * iSize) + iXOffset;
    points[7].y = (11 * iSize) + iYOffset;
    points[8].x = (2 * iSize) + iXOffset;
    points[8].y = (17 * iSize) + iYOffset;
    points[9].x = (13 * iSize) + iXOffset;
    points[9].y = (17 * iSize) + iYOffset;
	// ΰ ä   ۿ ׸.
	m_SmartPrint.SetPenStyle(RGB(12, 0, 50), 5);
	m_SmartPrint.SetBrushStyle(RGB(33, 77, 0), false);
	m_SmartPrint.Polygon(points, 10);

	//  ׸  ǥ   
	iXOffset = 1790;
	iYOffset = 1200;
	iSize = 15;
	points[0].x = (16 * iSize) + iXOffset;
    points[0].y = (28 * iSize) + iYOffset;
    points[1].x = (19 * iSize) + iXOffset;
    points[1].y = (17 * iSize) + iYOffset;
    points[2].x = (30 * iSize) + iXOffset;
    points[2].y = (17 * iSize) + iYOffset;
    points[3].x = (21 * iSize) + iXOffset;
    points[3].y = (11 * iSize) + iYOffset;
    points[4].x = (25 * iSize) + iXOffset;
    points[4].y = (1 * iSize) + iYOffset;
    points[5].x = (16 * iSize) + iXOffset;
    points[5].y = (7 * iSize) + iYOffset;
    points[6].x = (7 * iSize) + iXOffset;
    points[6].y = (1 * iSize) + iYOffset;
    points[7].x = (11 * iSize) + iXOffset;
    points[7].y = (11 * iSize) + iYOffset;
    points[8].x = (2 * iSize) + iXOffset;
    points[8].y = (17 * iSize) + iYOffset;
    points[9].x = (13 * iSize) + iXOffset;
    points[9].y = (17 * iSize) + iYOffset;
	// ΰ    ۿ ׸.
	m_SmartPrint.SetPenStyle(RGB(77, 23, 20), 50);
	m_SmartPrint.SetBrushStyle(RGB(255, 255, 255), true);
	m_SmartPrint.Polygon(points, 10);

	// SmartX  
	//m_SmartPrint.ImageDraw(IDB_BITMAP2, 100, 1750);
	m_SmartPrint.ImageDraw(IDB_BITMAP3, 210, 1850, 1000 * 2, 450 * 2);

	// ڵ  ۿ Ѵ. SmartX 
	m_SmartPrint.SetPenStyle(RGB(0, 150, 50), 3);
	m_SmartPrint.SetBrushStyle(RGB(0, 10, 30), false);
	m_SmartPrint.RoundRect(100, 2900, 2220, 330, 40);
	m_SmartPrint.SetFontCfg(L"ü", 47, RGB(255, 255, 255), true, false, false);
	m_SmartPrint.TextOut(120, 2950, L"SmartX HNS   ο  Ӻ .NET Ʈ(̺귯)");
	m_SmartPrint.TextOut(120, 3040, L" ĪϿ SmartX մϴ. ġα׷ ߽ SmartX Ͻø IEC1000");
	m_SmartPrint.TextOut(120, 3130, L"ϵ   ̽  ϰ  óҼ ֽϴ.");

	//  ۿ ׷ ͸ μ  մϴ.
	m_SmartPrint.PrintOut();

	// μ  Ȯ Ÿ̸
	SetTimer(3, 500, NULL);
}


void CSmartPrintEVCDlg::OnTimer(UINT_PTR nIDEvent)
{
	//  μ   Ȯ 
	if(nIDEvent == 3)
	{	
		switch(m_SmartPrint.IsPrinting())
        {
            case 2:
                m_LabPrnStatus.SetWindowTextW(L"μ ...");
                KillTimer(3);
                break;
            case 1:
                m_LabPrnStatus.SetWindowTextW(L"μ ...");
                break;
            case 0:
                m_LabPrnStatus.SetWindowTextW(L"μ Ϸ/غ...");
                KillTimer(3);
                break;
		}
	}

	CDialog::OnTimer(nIDEvent);
}

// α׷ 
void CSmartPrintEVCDlg::OnBnClickedButton2()
{
	OnOK();
}
