///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Class SmartPrint  C++(EVC++, Visual Studio 2005, 2008) ϵ Wrapping ClassԴϴ.
//  Class ϱ ؼ SmartPrintWrap.h SmartPrintWrap.cpp  Ʈ Ͽ Ͻñ ٶϴ.
//    Ե "DLL\SmartPrint.dll" Ǵ ϰ   Ͽ Ͻñ ٶϴ.
//  
// ڼ  SmartX ޴  Ͻñ ٶϴ.
//
// SmartX copyright(c)2002 All rights reserved by HNS Corp.   www.hnsts.co.kr
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "SmartPrintWrap.h"

CSmartPrintWrap::CSmartPrintWrap(void)
{
	m_hInst = LoadLibrary(L"SmartPrint.dll");

    if(m_hInst == NULL)
	{
        return;
	}

	//AfxSetResourceHandle(m_hInst);


	// ̽ ȹ  (̽ νϽ óѴ.)
    m_pfPrintSetup = (PrintSetupEx)GetProcAddress(m_hInst, _T("PrintSetup"));
	m_pfNewPage = (NewPageEx)GetProcAddress(m_hInst, _T("NewPage"));
	m_pfPrintOut = (PrintOutEx)GetProcAddress(m_hInst, _T("PrintOut"));
	m_pfIsPrinting = (IsPrintingEx)GetProcAddress(m_hInst, _T("IsPrinting"));
	m_pfGetPaperPixel = (GetPaperPixelEx)GetProcAddress(m_hInst, _T("GetPaperPixel"));
	m_pfErase = (EraseEx)GetProcAddress(m_hInst, _T("Erase"));
	m_pfSetPixels = (SetPixelsEx)GetProcAddress(m_hInst, _T("SetPixels"));
	m_pfLine = (LineEx)GetProcAddress(m_hInst, _T("Line"));
	m_pfPolylines = (PolylinesEx)GetProcAddress(m_hInst, _T("Polylines"));
	m_pfPolygons = (PolygonsEx)GetProcAddress(m_hInst, _T("Polygons"));
	m_pfRectangles = (RectanglesEx)GetProcAddress(m_hInst, _T("Rectangles"));
	m_pfRoundRect1 = (RoundRect1Ex)GetProcAddress(m_hInst, _T("RoundRect1"));
	m_pfRoundRect2 = (RoundRect2Ex)GetProcAddress(m_hInst, _T("RoundRect2"));
	m_pfCircle = (CircleEx)GetProcAddress(m_hInst, _T("Circle"));
	m_pfEllipses = (EllipsesEx)GetProcAddress(m_hInst, _T("Ellipses"));
	m_pfGradientFills = (GradientFillsEx)GetProcAddress(m_hInst, _T("GradientFills"));
	m_pfTextOut = (TextOutEx)GetProcAddress(m_hInst, _T("TextOut"));
	m_pfImageDraw1 = (ImageDraw1Ex)GetProcAddress(m_hInst, _T("ImageDraw1"));
	m_pfImageDraw2 = (ImageDraw2Ex)GetProcAddress(m_hInst, _T("ImageDraw2"));
	m_pfImageDraw3 = (ImageDraw3Ex)GetProcAddress(m_hInst, _T("ImageDraw3"));
	m_pfImageDraw4 = (ImageDraw4Ex)GetProcAddress(m_hInst, _T("ImageDraw4"));

	m_pfSetBrushStyle = (SetBrushStyleEx)GetProcAddress(m_hInst, _T("SetBrushStyle"));
	
	m_pfSetPenStyle = (SetPenStyleEx)GetProcAddress(m_hInst, _T("SetPenStyle"));

	m_pfSetFontCfg1 = (SetFontCfg1Ex)GetProcAddress(m_hInst, _T("SetFontCfg1"));
	m_pfSetFontCfg2 = (SetFontCfg2Ex)GetProcAddress(m_hInst, _T("SetFontCfg2"));
	m_pfSetFontCfg3 = (SetFontCfg3Ex)GetProcAddress(m_hInst, _T("SetFontCfg3"));

	m_pfDisplayToPrint1 = (DisplayToPrint1Ex)GetProcAddress(m_hInst, _T("DisplayToPrint1"));
	m_pfDisplayToPrint2 = (DisplayToPrint2Ex)GetProcAddress(m_hInst, _T("DisplayToPrint2"));

	m_pfSethInstance = (SethInstanceEx)GetProcAddress(m_hInst, _T("SethInstance"));
}

CSmartPrintWrap::~CSmartPrintWrap(void)
{
	FreeLibrary(m_hInst);
}

//  ʱȭ  
// strPrintID  ̸ PCL Inkjet or PCL Laserjet
// iQuality : μ ػ󵵸  մϴ. 0 : 300DPI, 1 : 600DPI
// iColorMode : Į  μ . 0 : , 1 : Į
// iPaperSize : μ  ũ⸦ . 
//				- 0 : A4 210 x 297 mm 		
//				- 2 : B5 (JIS) 182 x 257 mm
//				- 3 : Letter 8 1/2 x 11 in
//				- 4 : Legal 8 1/2 x 14 in
// iOrientation : μ     մϴ. 1 : , 0 : 
// iCopies : ݺ()μ 				
bool CSmartPrintWrap::PrintSetup(LPTSTR strPrinterID, int iQuality, int iColorMode, int iPaperSize, int iOrientation, int iCopies)
{
	return m_pfPrintSetup(strPrinterID, iQuality, iColorMode, iPaperSize, iOrientation, iCopies);
}

// ο Page   Page ڵ μ ˴ϴ.
void CSmartPrintWrap::NewPage()
{
	m_pfNewPage();
}

//  ۼ Page μ մϴ.(  )
void CSmartPrintWrap::PrintOut()
{
	m_pfPrintOut();
}

//  μ  Ȯ 
// 0 : Print standby or Print Output successful
// 1 : Printing
// 2 : Print failure
int CSmartPrintWrap::IsPrinting()
{
	return m_pfIsPrinting();
}

//   Paper  Pixel ´.
void CSmartPrintWrap::GetPaperPixel(int* iWidthPixel, int* iHeightPixel)
{
	m_pfGetPaperPixel(iWidthPixel, iHeightPixel);
}

//  µ͸ 
void CSmartPrintWrap::Erase()
{
	m_pfErase();
}

//  ǥ    ׸.
void CSmartPrintWrap::SetPixel(int iXPos, int iYPos, int crColor)
{
	m_pfSetPixels(iXPos, iYPos, crColor);
}

//  ׸
void CSmartPrintWrap::Line(int ifx, int ify, int isx, int isy)
{
	m_pfLine(ifx, ify, isx, isy);
}

// ӵ  ׸.
void CSmartPrintWrap::Polyline(POINT* pPoint, int iNum)
{
	m_pfPolylines(pPoint, iNum);
}

// ٰ ׸. SetBrushStyle Ӽ   ΰ ä(Fill)  ׸.
void CSmartPrintWrap::Polygon(POINT* pPoint, int iNum)
{
	m_pfPolygons(pPoint, iNum);
}

// 簢  ׸. SetBrushStyle Ӽ   ΰ ä(Fill)  ׸.
void CSmartPrintWrap::Rectangle(int iLeftX, int iTopY, int iWidth, int iHeight)
{
	m_pfRectangles(iLeftX, iTopY, iWidth, iHeight);
}

// 𼭸 ձ 簢 ׸. SetBrushStyle Ӽ   ΰ ä(Fill)  ׸.
void CSmartPrintWrap::RoundRect(int iLeftX, int iTopY, int iWidth, int iHeight, int iRWidth, int iRHeight)
{
	m_pfRoundRect1(iLeftX, iTopY, iWidth, iHeight, iRWidth, iRHeight);
}

// 𼭸 ձ 簢 ׸. SetBrushStyle Ӽ   ΰ ä(Fill)  ׸.
void CSmartPrintWrap::RoundRect(int iLeftX, int iTopY, int iWidth, int iHeight, int iRadius)
{
	m_pfRoundRect2(iLeftX, iTopY, iWidth, iHeight, iRadius);
}

//  ׸. SetBrushStyle Ӽ   ΰ ä(Fill)  ׸.
void CSmartPrintWrap::Circle(int iCenX, int iCenY, int iDiameter)
{
	m_pfCircle(iCenX, iCenY, iDiameter);
}

// Ÿ ׸. SetBrushStyle Ӽ   ΰ ä(Fill)  ׸.
void CSmartPrintWrap::Ellipse(int iCenX, int iCenY, int iWidth, int iHeight)
{
	m_pfEllipses(iCenX, iCenY, iWidth, iHeight);
}

// ׶̼ ó 簢 ׸.
void CSmartPrintWrap::GradientFill(int iLeftX, int iTopY, int iWidth, int iHeight, int startColor, int endColor, int dwMode)
{
	m_pfGradientFills(iLeftX, iTopY, iWidth, iHeight, startColor, endColor, dwMode);
}

// ؽƮ  մϴ.
void CSmartPrintWrap::TextOut(int iXpos, int iYpos, LPTSTR strFormat, ...)
{
	TCHAR strMsg[5000];

	va_list ap;
	 
    va_start(ap, strFormat); 
  
	vswprintf(strMsg, strFormat, ap);

	m_pfTextOut(iXpos, iYpos, strMsg);
}

// ̹   մϴ.(BMP)
void CSmartPrintWrap::ImageDraw(int iResourceID, int iXpos, int iYpos, int iWidth, int iHeight)
{
	m_pfImageDraw1(iResourceID, iXpos, iYpos, iWidth, iHeight);
}

// ̹   մϴ.(BMP)
void CSmartPrintWrap::ImageDraw(int iResourceID, int iXpos, int iYpos)
{
	m_pfImageDraw2(iResourceID, iXpos, iYpos);
}

// ̹   մϴ.(BMP, JPG, PNG, GIF)
void CSmartPrintWrap::ImageDraw(LPCTSTR strFilePath, int iXpos, int iYpos, int iWidth, int iHeight)
{
	m_pfImageDraw3(strFilePath, iXpos, iYpos, iWidth, iHeight);
}

// ̹   մϴ.(BMP, JPG, PNG, GIF)
void CSmartPrintWrap::ImageDraw(LPCTSTR strFilePath, int iXpos, int iYpos)
{
	m_pfImageDraw4(strFilePath, iXpos, iYpos);
}

// 귯 Ӽ  մϴ. Ӽ   ΰ ä(Fill)Ǵ   ׸.
void CSmartPrintWrap::SetBrushStyle(int brushColor, bool bTransparent)
{
	m_pfSetBrushStyle(brushColor, bTransparent);
}

//  ܰ  β  մϴ.
void CSmartPrintWrap::SetPenStyle(int penColor, int iWidth)
{
	m_pfSetPenStyle(penColor, iWidth);
}

// TextOut  Font Ӽ   մϴ.
void CSmartPrintWrap::SetFontCfg(LPTSTR strFontName, int iFontSize, int cFontColor, bool bBold, bool bItalic, bool bAntiAlased)
{
	m_pfSetFontCfg1(strFontName, iFontSize, cFontColor, bBold, bItalic, bAntiAlased);
}

// TextOut  Font Ӽ   մϴ.
void CSmartPrintWrap::SetFontCfg(LPTSTR strFontName, int iFontSize, int cFontColor)
{
	m_pfSetFontCfg2(strFontName, iFontSize, cFontColor);
}

// TextOut  Font Ӽ   մϴ.
void CSmartPrintWrap::SetFontCfg(int iFontSize, int cFontColor)
{
	m_pfSetFontCfg3(iFontSize, cFontColor);
}

//  IEC1000 Display¸ μմϴ.
void CSmartPrintWrap::DisplayToPrint(int iXpos, int iYpos, int iWidth, int iHeight)
{
	m_pfDisplayToPrint1(iXpos, iYpos, iWidth, iHeight);
}

//  IEC1000 Display¸ μմϴ.
void CSmartPrintWrap::DisplayToPrint(int iXpos, int iYpos)
{
	m_pfDisplayToPrint2(iXpos, iYpos);
}

void CSmartPrintWrap::SethInstance(HINSTANCE hInstance)
{
	m_pfSethInstance(hInstance);
}