// SmartSoundEVCDlg.cpp :  
//

#include "stdafx.h"
#include "SmartSoundEVC.h"
#include "SmartSoundEVCDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CSmartSoundEVCDlg ȭ 

CSmartSoundEVCDlg::CSmartSoundEVCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSmartSoundEVCDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSmartSoundEVCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TXTFILEPATH, m_txtFilePath);
}

BEGIN_MESSAGE_MAP(CSmartSoundEVCDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, OnButFileSel)
	ON_BN_CLICKED(IDC_BUTTON2, OnButPlay)
	ON_BN_CLICKED(IDC_BUTTON3, OnButPause)
	ON_BN_CLICKED(IDC_BUTTON4, OnButStop)
	ON_BN_CLICKED(IDC_BUTTON5, OnButVolUp)
	ON_BN_CLICKED(IDC_BUTTON6, OnButVolDown)
	ON_WM_CLOSE()
END_MESSAGE_MAP()


// CSmartSoundEVCDlg ޽ ó

BOOL CSmartSoundEVCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//  ȭ   մϴ.  α׷  â ȭ ڰ ƴ 쿡
	//  ӿũ  ۾ ڵ մϴ.
	SetIcon(m_hIcon, TRUE);			// ū  մϴ.
	SetIcon(m_hIcon, FALSE);		//   մϴ.

	m_SmartSound.SetVolume(0x7FFF);

	return TRUE;  // Ŀ Ʈѿ   TRUE ȯմϴ.
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CSmartSoundEVCDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_SMARTSOUNDEVC_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_SMARTSOUNDEVC_DIALOG));
	}
}
#endif

void CSmartSoundEVCDlg::OnButFileSel()
{
	CString strPathName;
	CString strFileName;

	TCHAR szFilter[] = L"*.*||";
	CFileDialog dlg(TRUE, NULL, NULL, OFN_HIDEREADONLY, szFilter);

	if(IDOK != dlg.DoModal())
	{
		return;
	}
	strPathName = dlg.GetPathName();
	m_txtFilePath.SetWindowText(strPathName);

	// ÷   θ ڿ 
	m_SmartSound.SetPlayFilePath(strPathName.GetBuffer(200));
}

// SetPlayFilePath()   ÷
void CSmartSoundEVCDlg::OnButPlay()
{
	m_SmartSound.Play_Sound();
}

//   ÷߿ ִ  ÷̸  ߴ
void CSmartSoundEVCDlg::OnButPause()
{
	m_SmartSound.Pause_Sound();
}

// ÷ ̸ ָ 
void CSmartSoundEVCDlg::OnButStop()
{
	m_SmartSound.Stop_Sound();
}

//  0x51E(16) ŭ. 0xFFFF(16) Ҽִ ִ밪
void CSmartSoundEVCDlg::OnButVolUp()
{
	DWORD dwVol = m_SmartSound.GetVolume();
	dwVol += 0x51E;

	if(dwVol > 0xFFFF)
	{
		dwVol = 0xFFFF;
	}
	m_SmartSound.SetVolume(dwVol);
}

//  0x51E(16) 
void CSmartSoundEVCDlg::OnButVolDown()
{
	DWORD dwVol = m_SmartSound.GetVolume();
	dwVol -= 0x51E;

	if(dwVol <= 0x0000)
	{
		dwVol = 0x0000;
	}
	m_SmartSound.SetVolume(dwVol);
}

// α׷ 
void CSmartSoundEVCDlg::OnClose()
{
	//   ̽ ȯ մϴ.
	FreeLibrary(m_hInst);
	CDialog::OnClose();
}