///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Class SmartUpdate  C++(EVC++, Visual Studio 2005, 2008) ϵ Wrapping ClassԴϴ.
//  Class ϱ ؼ SmartUpdateWrap.h SmartUpdateWrap.cpp  Ʈ Ͽ Ͻñ ٶϴ.
//    Ե "DLL\SmartUpDate.dll" Ǵ ϰ   Ͽ Ͻñ ٶϴ.
//  
// ڼ  SmartX ޴  Ͻñ ٶϴ.
//
// SmartX copyright(c)2002 All rights reserved by HNS Corp.   www.hnsts.co.kr
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "SmartUpdateWrap.h"

CSmartUpdateWrap::CSmartUpdateWrap(void)
{
	m_hInst = LoadLibrary(L"SmartUpDate.dll");

    if(m_hInst == NULL)
	{
        return;
	}


	// ̽ ȹ  (̽ νϽ óѴ.)
	m_pfSetPath = (SetPathEx)GetProcAddress(m_hInst, _T("SetPath"));
	m_pfSetBackImagePath = (SetBackImagePathEx)GetProcAddress(m_hInst, _T("SetBackImagePath"));
	m_pfSetDisplayText = (SetDisplayTextEx)GetProcAddress(m_hInst, _T("SetDisplayText"));
	m_pfSetDisplayTextColor = (SetDisplayTextColorEx)GetProcAddress(m_hInst, _T("SetDisplayTextColor"));
	m_pfSetStartInterval = (SetStartIntervalEx)GetProcAddress(m_hInst, _T("SetStartInterval"));
	m_pfSetReboot = (SetRebootEx)GetProcAddress(m_hInst, _T("SetReboot"));
	m_pfStart = (StartEx)GetProcAddress(m_hInst, _T("Start"));

}

CSmartUpdateWrap::~CSmartUpdateWrap(void)
{
	FreeLibrary(m_hInst);
}

// Ʈ ü  θ  մϴ.
void CSmartUpdateWrap::SetPath(LPWSTR strFromFile, LPWSTR strToFile)
{
	m_pfSetPath(strFromFile, strToFile);
}

// Ʈ  ȭ鿡 µ  ̹ θ  մϴ.
void CSmartUpdateWrap::SetBackImagePath(LPWSTR strImgFilePath)
{
	m_pfSetBackImagePath(strImgFilePath);
}

// Ʈ  ȭ鿡 µ ޽  մϴ. 
// [] strTitle :  ߾ӿ µǴ ޽, strMessage : ߰ ǥõǴ ޽
// strCompanyName : ϴ  ǥõǴ ޽
void CSmartUpdateWrap::SetDisplayText(LPWSTR strTitle, LPWSTR strMessage, LPWSTR strCompanyName)
{
	m_pfSetDisplayText(strTitle, strMessage, strCompanyName);
}

// Ʈ  ȭ鿡  ޽    մϴ. 
void CSmartUpdateWrap::SetDisplayTextColor(COLORREF crTitelColor, COLORREF crMsgColor, COLORREF crCompanyColor)
{
	m_pfSetDisplayTextColor((DWORD)crTitelColor, (DWORD)crMsgColor, (DWORD)crCompanyColor);
}

//  α׷  Ʈ  Ʈ ϱ  ð  
void CSmartUpdateWrap::SetStartInterval(DWORD dwInterval)
{
	m_pfSetStartInterval(dwInterval);
}

// Ʈ Ϸ ٽ  Ұ 
void CSmartUpdateWrap::SetReboot(int iReboot)
{
	m_pfSetReboot(iReboot);
}

// Ʈ Check 
// Update File Ȯ ϸ Ʈ    Ʈ 
// ϰ : Ʈ   ִ° True, Ʈ   ° False
// ءء[߿] Ʈ    ݵ  α׷  ؾ մϴ.!!! [߿]ءء
BOOL CSmartUpdateWrap::Start()
{
	return m_pfStart();
}