// SmartVideoEVCDlg.cpp :  
#include "stdafx.h"
#include "SmartVideoEVC.h"
#include "SmartVideoEVCDlg.h"
#include "SmartVideoCapDlg.h"
#include "SmartVideoEncParamDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSmartVideoEVCDlg ȭ 

CSmartVideoEVCDlg::CSmartVideoEVCDlg(CWnd* pParent /*=NULL*/)
: CDialog(CSmartVideoEVCDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSmartVideoEVCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CAMPREVIEW, m_CamPreView);
	DDX_Control(pDX, IDC_BUTEXIT, m_ButExit);
	DDX_Control(pDX, IDC_FRAME1, m_Frame1);
	DDX_Control(pDX, IDC_RADCH1, m_Ch1);
	DDX_Control(pDX, IDC_RADCH2, m_Ch2);
	DDX_Control(pDX, IDC_RADCH3, m_Ch3);
	DDX_Control(pDX, IDC_RADCH4, m_Ch4);

	DDX_Control(pDX, IDC_LABVALUE, m_LabValue);
	DDX_Control(pDX, IDC_RADBR, m_BR);
	DDX_Control(pDX, IDC_LABRES, m_LabEncRes);
	DDX_Control(pDX, IDC_LABRES2, m_LabPRES);
}

BEGIN_MESSAGE_MAP(CSmartVideoEVCDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTEXIT, &CSmartVideoEVCDlg::OnBnClickedButexit)
	ON_WM_LBUTTONDBLCLK()
	ON_STN_CLICKED(IDC_CAMPREVIEW, &CSmartVideoEVCDlg::OnStnClickedCampreview)
	ON_BN_CLICKED(IDC_RADCH1, &CSmartVideoEVCDlg::OnBnClickedRadch1)
	ON_BN_CLICKED(IDC_RADCH2, &CSmartVideoEVCDlg::OnBnClickedRadch2)
	ON_BN_CLICKED(IDC_RADCH3, &CSmartVideoEVCDlg::OnBnClickedRadch3)
	ON_BN_CLICKED(IDC_RADCH4, &CSmartVideoEVCDlg::OnBnClickedRadch4)
	ON_BN_CLICKED(IDC_RADBR, &CSmartVideoEVCDlg::OnBnClickedRadbr)
	ON_BN_CLICKED(IDC_RADHUE, &CSmartVideoEVCDlg::OnBnClickedRadhue)
	ON_BN_CLICKED(IDC_RADCOS, &CSmartVideoEVCDlg::OnBnClickedRadcos)
	ON_BN_CLICKED(IDC_RADCS, &CSmartVideoEVCDlg::OnBnClickedRadcs)
	ON_BN_CLICKED(IDC_BUTDEC, &CSmartVideoEVCDlg::OnBnClickedButdec)
	ON_BN_CLICKED(IDC_BUTINC, &CSmartVideoEVCDlg::OnBnClickedButinc)
	ON_BN_CLICKED(IDC_BUTDEFAULT, &CSmartVideoEVCDlg::OnBnClickedButdefault)
	ON_BN_CLICKED(IDC_BUTSTART, &CSmartVideoEVCDlg::OnBnClickedButstart)
	ON_BN_CLICKED(IDC_BUTSTOP, &CSmartVideoEVCDlg::OnBnClickedButstop)
	ON_BN_CLICKED(IDC_BUTEND, &CSmartVideoEVCDlg::OnBnClickedButend)
	ON_BN_CLICKED(IDC_BUTDOWN, &CSmartVideoEVCDlg::OnBnClickedButdown)
	ON_BN_CLICKED(IDC_BUTUP, &CSmartVideoEVCDlg::OnBnClickedButup)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_BUTSSAVE, &CSmartVideoEVCDlg::OnBnClickedButssave)
	ON_BN_CLICKED(IDC_BUTCAP, &CSmartVideoEVCDlg::OnBnClickedButcap)
	ON_BN_CLICKED(IDC_BUTDOWN2, &CSmartVideoEVCDlg::OnBnClickedButdown2)
	ON_BN_CLICKED(IDC_BUTUP2, &CSmartVideoEVCDlg::OnBnClickedButup2)
	ON_BN_CLICKED(IDC_BUTPRASET, &CSmartVideoEVCDlg::OnBnClickedButpraset)
END_MESSAGE_MAP()


// CSmartVideoEVCDlg ޽ ó

BOOL CSmartVideoEVCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//  ȭ   մϴ.  α׷  â ȭ ڰ ƴ 쿡
	//  ӿũ  ۾ ڵ մϴ.
	SetIcon(m_hIcon, TRUE);			// ū  մϴ.
	SetIcon(m_hIcon, FALSE);		//   մϴ.

	// TODO: ⿡ ߰ ʱȭ ۾ ߰մϴ.

	// ʱ ȭ Loading ī޶   غ  â  ó 
	this->ShowWindow(SW_HIDE);
	MoveWindow(0, 0, 800, 480);
	this->SetWindowTextW(L"HNS SmartX-SmartVideo www.hnsts.co.kr");

	m_CamPreView.ModifyStyle(0, SS_NOTIFY);

	////////////////////////////////////////////////////////////////////////
	//  Ʈ   ʱȭ - 
	m_ButExit.MoveWindow(610, 416, 180, 35);

	m_Ch1.SetCheck(true);
	m_BR.SetCheck(true);

	m_iNowSelect = 1;
	m_iEncodingResolution = 0;
	m_iPreviewResolution = 11;
	m_bIsFull = false;

	m_LabEncRes.SetWindowTextW(L"160X96");
	m_LabPRES.SetWindowTextW(L"576X432");

	m_iSettingValue[0] = 128;
	m_iSettingValue[1] = 0;
	m_iSettingValue[2] = 128;
	m_iSettingValue[3] = 128;

	TCHAR strValue[10];

	wsprintf(strValue, L"%d", m_iSettingValue[m_iNowSelect - 1]); 
	m_LabValue.SetWindowTextW(strValue);

	m_EncParas.iFrameRate = 30;
	m_EncParas.iBitRate = 4000;
	m_EncParas.iGOP = 60;
	m_EncParas.iIQP = 15;
	m_EncParas.iQPMax = 20;
	m_EncParas.fGamma = 0.75;
	//  Ʈ   ʱȭ - 
	////////////////////////////////////////////////////////////////////////

	// ʱ ȭ Loading ī޶   غ  
	// â  ó  ȭ  ó  Ÿ̸  
	SetTimer(3, 1, NULL);

	ShowCursor(FALSE);

	return TRUE;  // Ŀ Ʈѿ   TRUE ȯմϴ.
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CSmartVideoEVCDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_SMARTVIDEOEVC_DIALOG_WIDE) : 
		MAKEINTRESOURCE(IDD_SMARTVIDEOEVC_DIALOG));
	}
}
#endif

// Ÿ̸ ̺Ʈ Լ
void CSmartVideoEVCDlg::OnTimer(UINT_PTR nIDEvent)
{
	if(nIDEvent == 3)
	{
		// ʱ ȭ Loading۾   ī޶ ʱȭ Preview Ȱȭ Ŵ
		int iWidth, iHeight;

		// PreView Window(Control) ڵ 
		m_SmartVideo.SetPreviewWindowHandle(m_CamPreView.m_hWnd);
		// ī޶ ʱȭ Preview ػ 
		m_SmartVideo.Initialization(m_iPreviewResolution);
		//  Preview μ Pixel 
		m_SmartVideo.GetPreviewResolution(&iWidth, &iHeight);
		// Preview Window ġ ũ 
		m_CamPreView.MoveWindow(2, 2, iWidth, iHeight);
		// Preview  
		m_SmartVideo.Play();

		KillTimer(3);
	}

	CDialog::OnTimer(nIDEvent);
}


void CSmartVideoEVCDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// ׸ ޽ ؼ CDialog::OnPaint()() ȣ ʽÿ.

	// ϴ  ó
	CRect rtWin;
	rtWin.SetRect(0, 0, 800, 480);

	CBrush brush(RGB(100,222,10));

	dc.FillRect(&rtWin, &brush);

	dc.SetBkMode(TRANSPARENT);
	rtWin.left = 10;
	rtWin.top = 458;
	dc.DrawText(L"HNS SmartX-SmartVideo MFC Example  www.hnsts.co.kr", &rtWin, DT_LEFT);
}


// Exit ư ó(α׷ )
void CSmartVideoEVCDlg::OnBnClickedButexit()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	::PostMessage( this->m_hWnd, WM_QUIT, 0, 0 );
}


void CSmartVideoEVCDlg::OnStnClickedCampreview()
{
	// Preview Window  Ŭ üȭ ǥ
	FullResolution();
}

//  ȣ Է ä -1
void CSmartVideoEVCDlg::OnBnClickedRadch1()
{
	m_SmartVideo.SetSourceChannel(1);
}
//  ȣ Է ä -2
void CSmartVideoEVCDlg::OnBnClickedRadch2()
{
	m_SmartVideo.SetSourceChannel(2);
}
//  ȣ Է ä -3
void CSmartVideoEVCDlg::OnBnClickedRadch3()
{
	m_SmartVideo.SetSourceChannel(3);
}
//  ȣ Է ä -4
void CSmartVideoEVCDlg::OnBnClickedRadch4()
{
	m_SmartVideo.SetSourceChannel(4);
}

// ī޶  (Brightness)   
void CSmartVideoEVCDlg::OnBnClickedRadbr()
{
	TCHAR strValue[10];

	m_iNowSelect = 1;

	wsprintf(strValue, L"%d", m_iSettingValue[m_iNowSelect - 1]); 
	m_LabValue.SetWindowTextW(strValue);
}

// ī޶  (Hue)   
void CSmartVideoEVCDlg::OnBnClickedRadhue()
{
	TCHAR strValue[10];

	m_iNowSelect = 2;

	wsprintf(strValue, L"%d", m_iSettingValue[m_iNowSelect - 1]); 
	m_LabValue.SetWindowTextW(strValue);
}

// ī޶  (Contrast)   
void CSmartVideoEVCDlg::OnBnClickedRadcos()
{
	TCHAR strValue[10];

	m_iNowSelect = 3;

	wsprintf(strValue, L"%d", m_iSettingValue[m_iNowSelect - 1]); 
	m_LabValue.SetWindowTextW(strValue);
}

// ī޶  ä(Color Saturation)   
void CSmartVideoEVCDlg::OnBnClickedRadcs()
{
	TCHAR strValue[10];

	m_iNowSelect = 4;

	wsprintf(strValue, L"%d", m_iSettingValue[m_iNowSelect - 1]); 
	m_LabValue.SetWindowTextW(strValue);
}

//  õ  Ӽ(, , , ä) մϴ.(4Step )
void CSmartVideoEVCDlg::OnBnClickedButdec()
{
	TCHAR strValue[10];

	m_iSettingValue[m_iNowSelect - 1] = (m_iSettingValue[m_iNowSelect - 1] <= 0) ? 0 : m_iSettingValue[m_iNowSelect - 1] -= 4;

	wsprintf(strValue, L"%d", m_iSettingValue[m_iNowSelect - 1]); 
	m_LabValue.SetWindowTextW(strValue);

	//  õ Ӽ  ó
	switch(m_iNowSelect)
	{
	case 1:
		// 
		m_SmartVideo.SetBrightnessControl(m_iSettingValue[m_iNowSelect - 1]);
		break;
	case 2:
		// 
		m_SmartVideo.SetHueControl(m_iSettingValue[m_iNowSelect - 1]);
		break;
	case 3:
		// 
		m_SmartVideo.SetContrastControl(m_iSettingValue[m_iNowSelect - 1]);
		break;
	case 4:
		// ä
		m_SmartVideo.SetColorSaturationControl(m_iSettingValue[m_iNowSelect - 1]);
		break;
	}
}

//  õ  Ӽ(, , , ä) մϴ.(4Step )
void CSmartVideoEVCDlg::OnBnClickedButinc()
{
	TCHAR strValue[10];

	m_iSettingValue[m_iNowSelect - 1] = (m_iSettingValue[m_iNowSelect - 1] >= 255) ? 255 : m_iSettingValue[m_iNowSelect - 1] += 4;

	wsprintf(strValue, L"%d", m_iSettingValue[m_iNowSelect - 1]); 
	m_LabValue.SetWindowTextW(strValue);

	//  õ Ӽ  ó
	switch(m_iNowSelect)
	{
	case 1:
		// 
		m_SmartVideo.SetBrightnessControl(m_iSettingValue[m_iNowSelect - 1]);
		break;
	case 2:
		// 
		m_SmartVideo.SetHueControl(m_iSettingValue[m_iNowSelect - 1]);
		break;
	case 3:
		// 
		m_SmartVideo.SetContrastControl(m_iSettingValue[m_iNowSelect - 1]);
		break;
	case 4:
		// ä
		m_SmartVideo.SetColorSaturationControl(m_iSettingValue[m_iNowSelect - 1]);
		break;
	}
}

//  õ  Ӽ(, , , ä) ⺻ 
void CSmartVideoEVCDlg::OnBnClickedButdefault()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	m_iSettingValue[0] = 128;
	m_iSettingValue[1] = 0;
	m_iSettingValue[2] = 128;
	m_iSettingValue[3] = 128;

	TCHAR strValue[10];

	wsprintf(strValue, L"%d", m_iSettingValue[m_iNowSelect - 1]); 
	m_LabValue.SetWindowTextW(strValue);

	m_SmartVideo.SetDefaultControl();
}

// ư ι  Ŭ üũ bool Ÿ  m_bEncoding 
bool m_bEncoding = false;

//   
void CSmartVideoEVCDlg::OnBnClickedButstart()
{
	// butSt ŬǸ butSt Ȱȭ.  ι  
	GetDlgItem(IDC_BUTSTART) -> EnableWindow(FALSE);

	if (m_bEncoding == false)
	{
		//     ĸ 
		m_SmartVideo.SetEncodingParameter1(L"SD Card\\jmKim.264", m_EncParas.iFrameRate, m_EncParas.iBitRate);
		m_SmartVideo.SetEncodingParameter2(m_EncParas.iGOP, m_EncParas.iIQP, m_EncParas.iQPMax, m_EncParas.fGamma);
		//   ʱȭ
		m_SmartVideo.InitEncoding();
		//   
		m_SmartVideo.RunEncoding();

		// Thread.Sleep  óð ø
		Sleep( 100 );
		// ݵ butEnd ѹ Ǿ߸ butSt ǵ
		m_bEncoding = true;
	}
	// butSt Ǵ  butSt Ȱȭ
	GetDlgItem(IDC_BUTSTART) -> EnableWindow(TRUE);
}
//    
void CSmartVideoEVCDlg::OnBnClickedButstop()
{
	m_SmartVideo.StopEncoding();
}
//   
void CSmartVideoEVCDlg::OnBnClickedButend()
{
	// butEnd  ŬǸ butEnd Ȱȭ
	GetDlgItem(IDC_BUTEND) -> EnableWindow(FALSE);
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	m_SmartVideo.EndEncoding();
	// Thread.Sleep  óð ø
	Sleep( 100 );
	// butEnd ŬǾ߸ butSt ɼֵ  
	m_bEncoding = false;
	// butEnd Ȱȭ
	GetDlgItem(IDC_BUTEND) -> EnableWindow(TRUE);
}

// ,   ػ   
void CSmartVideoEVCDlg::OnBnClickedButdown()
{
	int iWidth, iHeight;
	CString strValue;

	m_iEncodingResolution = (m_iEncodingResolution <= 0) ? 0 : --m_iEncodingResolution;

	// Capture ػ 
	m_SmartVideo.SetCaptureResolution(m_iEncodingResolution);
	//  Capture ػ 
	m_SmartVideo.GetCaptureResolution(&iWidth, &iHeight);

	strValue.Format(L"%dX%d", iWidth, iHeight); 

	m_LabEncRes.SetWindowTextW(strValue);
}
// ,   ػ   
void CSmartVideoEVCDlg::OnBnClickedButup()
{
	int iWidth, iHeight;
	CString strValue;

	m_iEncodingResolution = (m_iEncodingResolution >= 12) ? 12 : ++m_iEncodingResolution;

	// Capture ػ 
	m_SmartVideo.SetCaptureResolution(m_iEncodingResolution);
	//  Capture ػ 
	m_SmartVideo.GetCaptureResolution(&iWidth, &iHeight);

	strValue.Format(L"%dX%d", iWidth, iHeight); 

	m_LabEncRes.SetWindowTextW(strValue);
}

//    ̹ Ϸ  մϴ.
//   : BMP, JPG, PNG, GIF
void CSmartVideoEVCDlg::OnBnClickedButssave()
{
	m_SmartVideo.CaptureStillImage(L"SD Card\\SmartX.jpg");
	AfxMessageBox(L"SD Card\\SmartX.jpg  !!!");
}

//   RAW Data(BMP) ´. Memory Capture
void CSmartVideoEVCDlg::OnBnClickedButcap()
{
	CSmartVideoCapDlg CapMemDlg;
	int iWidth, iHeight;
	LARGE_INTEGER freq, start, end;
	double lapse;
	bool bFail = false;

	m_SmartVideo.GetCaptureResolution(&iWidth, &iHeight);

	//  ũ⸸ŭ ޸ Ҵ
	unsigned char* Raw = new unsigned char[(iWidth * iHeight) * 3];

	// Memory Capture ð   ó
	QueryPerformanceFrequency(&freq);
	// ð  
	QueryPerformanceCounter(&start);

	// ޸𸮷   
	if(m_SmartVideo.ImageMemoryCapture(Raw) == false)
	{
		bFail = true;
	}
	else
	{
		bFail = false;
	}

	// ð  Ϸ
	QueryPerformanceCounter(&end);

	// ҿð 
	lapse = (double)(end.QuadPart - start.QuadPart) / freq.QuadPart;

	if(bFail == true)
	{
		AfxMessageBox(L"ImageMemoryCapture Fail...");
	}

	CString strMsg;
	strMsg.Format(L"Memory Capture ҿð : %f ms", lapse * 1000);
	AfxMessageBox(strMsg);

	// ޸𸮷   ȭ鿡  ó
	CapMemDlg.SetCaptureMemoryInfo(Raw, (iWidth * iHeight) * 3);

	CapMemDlg.DoModal();

	//  ޸ 
	delete[] Raw;
}

// ̸(Preview)  ػ   
void CSmartVideoEVCDlg::OnBnClickedButdown2()
{
	int iWidth, iHeight;
	CString strValue;

	m_iPreviewResolution = (m_iPreviewResolution <= 0) ? 0 : --m_iPreviewResolution;

	m_SmartVideo.SetPreviewResolution(m_iPreviewResolution);

	m_SmartVideo.GetPreviewResolution(&iWidth, &iHeight);

	strValue.Format(L"%dX%d", iWidth, iHeight); 

	m_LabPRES.SetWindowTextW(strValue);
}
// ̸(Preview)  ػ   
void CSmartVideoEVCDlg::OnBnClickedButup2()
{
	int iWidth, iHeight;
	CString strValue;

	m_iPreviewResolution = (m_iPreviewResolution >= 16) ? 16 : ++m_iPreviewResolution;

	m_SmartVideo.SetPreviewResolution(m_iPreviewResolution);

	m_SmartVideo.GetPreviewResolution(&iWidth, &iHeight);

	strValue.Format(L"%dX%d", iWidth, iHeight); 

	m_LabPRES.SetWindowTextW(strValue);	
}

// Preview ȭ ü ǥø ó
void CSmartVideoEVCDlg::FullResolution()
{
	if(m_bIsFull == true)
	{
		// ̹ ü ȭ   ⺻ ػ󵵷 
		int iWidth, iHeight;
		CString strValue;

		// ⺻ ̸ ػ 576 * 432
		m_iPreviewResolution = 11;
		m_CamPreView.MoveWindow(2, 2, 576, 432);
		m_SmartVideo.SetPreviewResolution(m_iPreviewResolution);
		m_SmartVideo.GetPreviewResolution(&iWidth, &iHeight);

		strValue.Format(L"%dX%d", iWidth, iHeight); 
		m_LabPRES.SetWindowTextW(strValue);

		m_bIsFull = false;
	}
	else
	{
		// ü ȭ ǥ ó
		m_CamPreView.MoveWindow(0, 0, 800, 600);

		m_SmartVideo.SetPreviewResolution(16);

		m_bIsFull = true;
	}
}
//  忡 ʿ ĸ  ϱ  â 
void CSmartVideoEVCDlg::OnBnClickedButpraset()
{
	CSmartVideoEncParamDlg  ParaSettingDlg;

	ParaSettingDlg.m_SetEncParas = m_EncParas;

	if(ParaSettingDlg.DoModal() == IDOK)
	{
		m_EncParas = ParaSettingDlg.m_SetEncParas;
	}
}
